/* Autogenerated by mlir-tblgen; don't manually edit */

#ifdef GEN_PASS_DECL
// Generate declarations for all passes.
#define GEN_PASS_DECL_FLATTENIO
#define GEN_PASS_DECL_FLATTENMODULES
#define GEN_PASS_DECL_FOOWIRES
#define GEN_PASS_DECL_HWSPECIALIZE
#define GEN_PASS_DECL_PRINTHWMODULEGRAPH
#define GEN_PASS_DECL_PRINTINSTANCEGRAPH
#define GEN_PASS_DECL_VERIFYINNERREFNAMESPACE
#undef GEN_PASS_DECL
#endif // GEN_PASS_DECL

//===----------------------------------------------------------------------===//
// FlattenIO
//===----------------------------------------------------------------------===//
#ifdef GEN_PASS_DECL_FLATTENIO
struct FlattenIOOptions {
  bool recursive = true;
  bool flattenExtern = false;
  char joinChar = '.';
};
#undef GEN_PASS_DECL_FLATTENIO
#endif // GEN_PASS_DECL_FLATTENIO
#ifdef GEN_PASS_DEF_FLATTENIO
namespace impl {

template <typename DerivedT>
class FlattenIOBase : public ::mlir::OperationPass<mlir::ModuleOp> {
public:
  using Base = FlattenIOBase;

  FlattenIOBase() : ::mlir::OperationPass<mlir::ModuleOp>(::mlir::TypeID::get<DerivedT>()) {}
  FlattenIOBase(const FlattenIOBase &other) : ::mlir::OperationPass<mlir::ModuleOp>(other) {}
  FlattenIOBase& operator=(const FlattenIOBase &) = delete;
  FlattenIOBase(FlattenIOBase &&) = delete;
  FlattenIOBase& operator=(FlattenIOBase &&) = delete;
  ~FlattenIOBase() = default;

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("hw-flatten-io");
  }
  ::llvm::StringRef getArgument() const override { return "hw-flatten-io"; }

  ::llvm::StringRef getDescription() const override { return "Flattens hw::Structure typed in- and output ports."; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("FlattenIO");
  }
  ::llvm::StringRef getName() const override { return "FlattenIO"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Return the dialect that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    
  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(FlattenIOBase<DerivedT>)

  FlattenIOBase(const FlattenIOOptions &options) : FlattenIOBase() {
    recursive = options.recursive;
    flattenExtern = options.flattenExtern;
    joinChar = options.joinChar;
  }
protected:
  ::mlir::Pass::Option<bool> recursive{*this, "recursive", ::llvm::cl::desc("Recursively flatten nested structs."), ::llvm::cl::init(true)};
  ::mlir::Pass::Option<bool> flattenExtern{*this, "flatten-extern", ::llvm::cl::desc("Flatten the extern modules also."), ::llvm::cl::init(false)};
  ::mlir::Pass::Option<char> joinChar{*this, "join-char", ::llvm::cl::desc("Use a custom character to construct the flattened names."), ::llvm::cl::init('.')};
private:
};
} // namespace impl
#undef GEN_PASS_DEF_FLATTENIO
#endif // GEN_PASS_DEF_FLATTENIO

//===----------------------------------------------------------------------===//
// FlattenModules
//===----------------------------------------------------------------------===//
#ifdef GEN_PASS_DECL_FLATTENMODULES
#undef GEN_PASS_DECL_FLATTENMODULES
#endif // GEN_PASS_DECL_FLATTENMODULES
#ifdef GEN_PASS_DEF_FLATTENMODULES
namespace impl {

template <typename DerivedT>
class FlattenModulesBase : public ::mlir::OperationPass<mlir::ModuleOp> {
public:
  using Base = FlattenModulesBase;

  FlattenModulesBase() : ::mlir::OperationPass<mlir::ModuleOp>(::mlir::TypeID::get<DerivedT>()) {}
  FlattenModulesBase(const FlattenModulesBase &other) : ::mlir::OperationPass<mlir::ModuleOp>(other) {}
  FlattenModulesBase& operator=(const FlattenModulesBase &) = delete;
  FlattenModulesBase(FlattenModulesBase &&) = delete;
  FlattenModulesBase& operator=(FlattenModulesBase &&) = delete;
  ~FlattenModulesBase() = default;

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("hw-flatten-modules");
  }
  ::llvm::StringRef getArgument() const override { return "hw-flatten-modules"; }

  ::llvm::StringRef getDescription() const override { return "Eagerly inline private modules"; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("FlattenModules");
  }
  ::llvm::StringRef getName() const override { return "FlattenModules"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Return the dialect that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    
  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(FlattenModulesBase<DerivedT>)

protected:
private:
};
} // namespace impl
#undef GEN_PASS_DEF_FLATTENMODULES
#endif // GEN_PASS_DEF_FLATTENMODULES

//===----------------------------------------------------------------------===//
// FooWires
//===----------------------------------------------------------------------===//
#ifdef GEN_PASS_DECL_FOOWIRES
#undef GEN_PASS_DECL_FOOWIRES
#endif // GEN_PASS_DECL_FOOWIRES
#ifdef GEN_PASS_DEF_FOOWIRES
namespace impl {

template <typename DerivedT>
class FooWiresBase : public ::mlir::OperationPass<hw::HWModuleOp> {
public:
  using Base = FooWiresBase;

  FooWiresBase() : ::mlir::OperationPass<hw::HWModuleOp>(::mlir::TypeID::get<DerivedT>()) {}
  FooWiresBase(const FooWiresBase &other) : ::mlir::OperationPass<hw::HWModuleOp>(other) {}
  FooWiresBase& operator=(const FooWiresBase &) = delete;
  FooWiresBase(FooWiresBase &&) = delete;
  FooWiresBase& operator=(FooWiresBase &&) = delete;
  ~FooWiresBase() = default;

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("hw-foo-wires");
  }
  ::llvm::StringRef getArgument() const override { return "hw-foo-wires"; }

  ::llvm::StringRef getDescription() const override { return "Change all wires' name to foo_<n>."; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("FooWires");
  }
  ::llvm::StringRef getName() const override { return "FooWires"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Return the dialect that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    
  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(FooWiresBase<DerivedT>)

protected:
private:
};
} // namespace impl
#undef GEN_PASS_DEF_FOOWIRES
#endif // GEN_PASS_DEF_FOOWIRES

//===----------------------------------------------------------------------===//
// HWSpecialize
//===----------------------------------------------------------------------===//
#ifdef GEN_PASS_DECL_HWSPECIALIZE
#undef GEN_PASS_DECL_HWSPECIALIZE
#endif // GEN_PASS_DECL_HWSPECIALIZE
#ifdef GEN_PASS_DEF_HWSPECIALIZE
namespace impl {

template <typename DerivedT>
class HWSpecializeBase : public ::mlir::OperationPass<mlir::ModuleOp> {
public:
  using Base = HWSpecializeBase;

  HWSpecializeBase() : ::mlir::OperationPass<mlir::ModuleOp>(::mlir::TypeID::get<DerivedT>()) {}
  HWSpecializeBase(const HWSpecializeBase &other) : ::mlir::OperationPass<mlir::ModuleOp>(other) {}
  HWSpecializeBase& operator=(const HWSpecializeBase &) = delete;
  HWSpecializeBase(HWSpecializeBase &&) = delete;
  HWSpecializeBase& operator=(HWSpecializeBase &&) = delete;
  ~HWSpecializeBase() = default;

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("hw-specialize");
  }
  ::llvm::StringRef getArgument() const override { return "hw-specialize"; }

  ::llvm::StringRef getDescription() const override { return "Specializes instances of parametric hw.modules"; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("HWSpecialize");
  }
  ::llvm::StringRef getName() const override { return "HWSpecialize"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Return the dialect that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    
  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(HWSpecializeBase<DerivedT>)

protected:
private:
};
} // namespace impl
#undef GEN_PASS_DEF_HWSPECIALIZE
#endif // GEN_PASS_DEF_HWSPECIALIZE

//===----------------------------------------------------------------------===//
// PrintHWModuleGraph
//===----------------------------------------------------------------------===//
#ifdef GEN_PASS_DECL_PRINTHWMODULEGRAPH
struct PrintHWModuleGraphOptions {
  bool verboseEdges = false;
};
#undef GEN_PASS_DECL_PRINTHWMODULEGRAPH
#endif // GEN_PASS_DECL_PRINTHWMODULEGRAPH
#ifdef GEN_PASS_DEF_PRINTHWMODULEGRAPH
namespace impl {

template <typename DerivedT>
class PrintHWModuleGraphBase : public ::mlir::OperationPass<mlir::ModuleOp> {
public:
  using Base = PrintHWModuleGraphBase;

  PrintHWModuleGraphBase() : ::mlir::OperationPass<mlir::ModuleOp>(::mlir::TypeID::get<DerivedT>()) {}
  PrintHWModuleGraphBase(const PrintHWModuleGraphBase &other) : ::mlir::OperationPass<mlir::ModuleOp>(other) {}
  PrintHWModuleGraphBase& operator=(const PrintHWModuleGraphBase &) = delete;
  PrintHWModuleGraphBase(PrintHWModuleGraphBase &&) = delete;
  PrintHWModuleGraphBase& operator=(PrintHWModuleGraphBase &&) = delete;
  ~PrintHWModuleGraphBase() = default;

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("hw-print-module-graph");
  }
  ::llvm::StringRef getArgument() const override { return "hw-print-module-graph"; }

  ::llvm::StringRef getDescription() const override { return "Print a DOT graph of the HWModule's within a top-level module."; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("PrintHWModuleGraph");
  }
  ::llvm::StringRef getName() const override { return "PrintHWModuleGraph"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Return the dialect that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    
  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(PrintHWModuleGraphBase<DerivedT>)

  PrintHWModuleGraphBase(const PrintHWModuleGraphOptions &options) : PrintHWModuleGraphBase() {
    verboseEdges = options.verboseEdges;
  }
protected:
  ::mlir::Pass::Option<bool> verboseEdges{*this, "verbose-edges", ::llvm::cl::desc("Print information on SSA edges (types, operand #, ...)"), ::llvm::cl::init(false)};
private:
};
} // namespace impl
#undef GEN_PASS_DEF_PRINTHWMODULEGRAPH
#endif // GEN_PASS_DEF_PRINTHWMODULEGRAPH

//===----------------------------------------------------------------------===//
// PrintInstanceGraph
//===----------------------------------------------------------------------===//
#ifdef GEN_PASS_DECL_PRINTINSTANCEGRAPH
#undef GEN_PASS_DECL_PRINTINSTANCEGRAPH
#endif // GEN_PASS_DECL_PRINTINSTANCEGRAPH
#ifdef GEN_PASS_DEF_PRINTINSTANCEGRAPH
namespace impl {

template <typename DerivedT>
class PrintInstanceGraphBase : public ::mlir::OperationPass<mlir::ModuleOp> {
public:
  using Base = PrintInstanceGraphBase;

  PrintInstanceGraphBase() : ::mlir::OperationPass<mlir::ModuleOp>(::mlir::TypeID::get<DerivedT>()) {}
  PrintInstanceGraphBase(const PrintInstanceGraphBase &other) : ::mlir::OperationPass<mlir::ModuleOp>(other) {}
  PrintInstanceGraphBase& operator=(const PrintInstanceGraphBase &) = delete;
  PrintInstanceGraphBase(PrintInstanceGraphBase &&) = delete;
  PrintInstanceGraphBase& operator=(PrintInstanceGraphBase &&) = delete;
  ~PrintInstanceGraphBase() = default;

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("hw-print-instance-graph");
  }
  ::llvm::StringRef getArgument() const override { return "hw-print-instance-graph"; }

  ::llvm::StringRef getDescription() const override { return "Print a DOT graph of the module hierarchy."; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("PrintInstanceGraph");
  }
  ::llvm::StringRef getName() const override { return "PrintInstanceGraph"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Return the dialect that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    
  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(PrintInstanceGraphBase<DerivedT>)

protected:
private:
};
} // namespace impl
#undef GEN_PASS_DEF_PRINTINSTANCEGRAPH
#endif // GEN_PASS_DEF_PRINTINSTANCEGRAPH

//===----------------------------------------------------------------------===//
// VerifyInnerRefNamespace
//===----------------------------------------------------------------------===//
#ifdef GEN_PASS_DECL_VERIFYINNERREFNAMESPACE
#undef GEN_PASS_DECL_VERIFYINNERREFNAMESPACE
#endif // GEN_PASS_DECL_VERIFYINNERREFNAMESPACE
#ifdef GEN_PASS_DEF_VERIFYINNERREFNAMESPACE
namespace impl {

template <typename DerivedT>
class VerifyInnerRefNamespaceBase : public ::mlir::OperationPass<> {
public:
  using Base = VerifyInnerRefNamespaceBase;

  VerifyInnerRefNamespaceBase() : ::mlir::OperationPass<>(::mlir::TypeID::get<DerivedT>()) {}
  VerifyInnerRefNamespaceBase(const VerifyInnerRefNamespaceBase &other) : ::mlir::OperationPass<>(other) {}
  VerifyInnerRefNamespaceBase& operator=(const VerifyInnerRefNamespaceBase &) = delete;
  VerifyInnerRefNamespaceBase(VerifyInnerRefNamespaceBase &&) = delete;
  VerifyInnerRefNamespaceBase& operator=(VerifyInnerRefNamespaceBase &&) = delete;
  ~VerifyInnerRefNamespaceBase() = default;

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("hw-verify-irn");
  }
  ::llvm::StringRef getArgument() const override { return "hw-verify-irn"; }

  ::llvm::StringRef getDescription() const override { return "Verify InnerRefNamespaceLike operations, if not self-verifying."; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("VerifyInnerRefNamespace");
  }
  ::llvm::StringRef getName() const override { return "VerifyInnerRefNamespace"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Return the dialect that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    
  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(VerifyInnerRefNamespaceBase<DerivedT>)

protected:
private:
};
} // namespace impl
#undef GEN_PASS_DEF_VERIFYINNERREFNAMESPACE
#endif // GEN_PASS_DEF_VERIFYINNERREFNAMESPACE
#ifdef GEN_PASS_REGISTRATION

//===----------------------------------------------------------------------===//
// FlattenIO Registration
//===----------------------------------------------------------------------===//

inline void registerFlattenIO() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return circt::hw::createFlattenIOPass();
  });
}

// Old registration code, kept for temporary backwards compatibility.
inline void registerFlattenIOPass() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return circt::hw::createFlattenIOPass();
  });
}

//===----------------------------------------------------------------------===//
// FlattenModules Registration
//===----------------------------------------------------------------------===//

inline void registerFlattenModules() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return circt::hw::createFlattenModulesPass();
  });
}

// Old registration code, kept for temporary backwards compatibility.
inline void registerFlattenModulesPass() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return circt::hw::createFlattenModulesPass();
  });
}

//===----------------------------------------------------------------------===//
// FooWires Registration
//===----------------------------------------------------------------------===//

inline void registerFooWires() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return circt::hw::createFooWiresPass();
  });
}

// Old registration code, kept for temporary backwards compatibility.
inline void registerFooWiresPass() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return circt::hw::createFooWiresPass();
  });
}

//===----------------------------------------------------------------------===//
// HWSpecialize Registration
//===----------------------------------------------------------------------===//

inline void registerHWSpecialize() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return circt::hw::createHWSpecializePass();
  });
}

// Old registration code, kept for temporary backwards compatibility.
inline void registerHWSpecializePass() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return circt::hw::createHWSpecializePass();
  });
}

//===----------------------------------------------------------------------===//
// PrintHWModuleGraph Registration
//===----------------------------------------------------------------------===//

inline void registerPrintHWModuleGraph() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return circt::hw::createPrintHWModuleGraphPass();
  });
}

// Old registration code, kept for temporary backwards compatibility.
inline void registerPrintHWModuleGraphPass() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return circt::hw::createPrintHWModuleGraphPass();
  });
}

//===----------------------------------------------------------------------===//
// PrintInstanceGraph Registration
//===----------------------------------------------------------------------===//

inline void registerPrintInstanceGraph() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return circt::hw::createPrintInstanceGraphPass();
  });
}

// Old registration code, kept for temporary backwards compatibility.
inline void registerPrintInstanceGraphPass() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return circt::hw::createPrintInstanceGraphPass();
  });
}

//===----------------------------------------------------------------------===//
// VerifyInnerRefNamespace Registration
//===----------------------------------------------------------------------===//

inline void registerVerifyInnerRefNamespace() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return circt::hw::createVerifyInnerRefNamespacePass();
  });
}

// Old registration code, kept for temporary backwards compatibility.
inline void registerVerifyInnerRefNamespacePass() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return circt::hw::createVerifyInnerRefNamespacePass();
  });
}

//===----------------------------------------------------------------------===//
//  Registration
//===----------------------------------------------------------------------===//

inline void registerPasses() {
  registerFlattenIO();
  registerFlattenModules();
  registerFooWires();
  registerHWSpecialize();
  registerPrintHWModuleGraph();
  registerPrintInstanceGraph();
  registerVerifyInnerRefNamespace();
}
#undef GEN_PASS_REGISTRATION
#endif // GEN_PASS_REGISTRATION
// Deprecated. Please use the new per-pass macros.
#ifdef GEN_PASS_CLASSES

template <typename DerivedT>
class FlattenIOBase : public ::mlir::OperationPass<mlir::ModuleOp> {
public:
  using Base = FlattenIOBase;

  FlattenIOBase() : ::mlir::OperationPass<mlir::ModuleOp>(::mlir::TypeID::get<DerivedT>()) {}
  FlattenIOBase(const FlattenIOBase &other) : ::mlir::OperationPass<mlir::ModuleOp>(other) {}
  FlattenIOBase& operator=(const FlattenIOBase &) = delete;
  FlattenIOBase(FlattenIOBase &&) = delete;
  FlattenIOBase& operator=(FlattenIOBase &&) = delete;
  ~FlattenIOBase() = default;

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("hw-flatten-io");
  }
  ::llvm::StringRef getArgument() const override { return "hw-flatten-io"; }

  ::llvm::StringRef getDescription() const override { return "Flattens hw::Structure typed in- and output ports."; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("FlattenIO");
  }
  ::llvm::StringRef getName() const override { return "FlattenIO"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Register the dialects that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    
  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(FlattenIOBase<DerivedT>)

protected:
  ::mlir::Pass::Option<bool> recursive{*this, "recursive", ::llvm::cl::desc("Recursively flatten nested structs."), ::llvm::cl::init(true)};
  ::mlir::Pass::Option<bool> flattenExtern{*this, "flatten-extern", ::llvm::cl::desc("Flatten the extern modules also."), ::llvm::cl::init(false)};
  ::mlir::Pass::Option<char> joinChar{*this, "join-char", ::llvm::cl::desc("Use a custom character to construct the flattened names."), ::llvm::cl::init('.')};
};

template <typename DerivedT>
class FlattenModulesBase : public ::mlir::OperationPass<mlir::ModuleOp> {
public:
  using Base = FlattenModulesBase;

  FlattenModulesBase() : ::mlir::OperationPass<mlir::ModuleOp>(::mlir::TypeID::get<DerivedT>()) {}
  FlattenModulesBase(const FlattenModulesBase &other) : ::mlir::OperationPass<mlir::ModuleOp>(other) {}
  FlattenModulesBase& operator=(const FlattenModulesBase &) = delete;
  FlattenModulesBase(FlattenModulesBase &&) = delete;
  FlattenModulesBase& operator=(FlattenModulesBase &&) = delete;
  ~FlattenModulesBase() = default;

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("hw-flatten-modules");
  }
  ::llvm::StringRef getArgument() const override { return "hw-flatten-modules"; }

  ::llvm::StringRef getDescription() const override { return "Eagerly inline private modules"; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("FlattenModules");
  }
  ::llvm::StringRef getName() const override { return "FlattenModules"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Register the dialects that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    
  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(FlattenModulesBase<DerivedT>)

protected:
};

template <typename DerivedT>
class FooWiresBase : public ::mlir::OperationPass<hw::HWModuleOp> {
public:
  using Base = FooWiresBase;

  FooWiresBase() : ::mlir::OperationPass<hw::HWModuleOp>(::mlir::TypeID::get<DerivedT>()) {}
  FooWiresBase(const FooWiresBase &other) : ::mlir::OperationPass<hw::HWModuleOp>(other) {}
  FooWiresBase& operator=(const FooWiresBase &) = delete;
  FooWiresBase(FooWiresBase &&) = delete;
  FooWiresBase& operator=(FooWiresBase &&) = delete;
  ~FooWiresBase() = default;

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("hw-foo-wires");
  }
  ::llvm::StringRef getArgument() const override { return "hw-foo-wires"; }

  ::llvm::StringRef getDescription() const override { return "Change all wires' name to foo_<n>."; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("FooWires");
  }
  ::llvm::StringRef getName() const override { return "FooWires"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Register the dialects that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    
  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(FooWiresBase<DerivedT>)

protected:
};

template <typename DerivedT>
class HWSpecializeBase : public ::mlir::OperationPass<mlir::ModuleOp> {
public:
  using Base = HWSpecializeBase;

  HWSpecializeBase() : ::mlir::OperationPass<mlir::ModuleOp>(::mlir::TypeID::get<DerivedT>()) {}
  HWSpecializeBase(const HWSpecializeBase &other) : ::mlir::OperationPass<mlir::ModuleOp>(other) {}
  HWSpecializeBase& operator=(const HWSpecializeBase &) = delete;
  HWSpecializeBase(HWSpecializeBase &&) = delete;
  HWSpecializeBase& operator=(HWSpecializeBase &&) = delete;
  ~HWSpecializeBase() = default;

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("hw-specialize");
  }
  ::llvm::StringRef getArgument() const override { return "hw-specialize"; }

  ::llvm::StringRef getDescription() const override { return "Specializes instances of parametric hw.modules"; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("HWSpecialize");
  }
  ::llvm::StringRef getName() const override { return "HWSpecialize"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Register the dialects that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    
  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(HWSpecializeBase<DerivedT>)

protected:
};

template <typename DerivedT>
class PrintHWModuleGraphBase : public ::mlir::OperationPass<mlir::ModuleOp> {
public:
  using Base = PrintHWModuleGraphBase;

  PrintHWModuleGraphBase() : ::mlir::OperationPass<mlir::ModuleOp>(::mlir::TypeID::get<DerivedT>()) {}
  PrintHWModuleGraphBase(const PrintHWModuleGraphBase &other) : ::mlir::OperationPass<mlir::ModuleOp>(other) {}
  PrintHWModuleGraphBase& operator=(const PrintHWModuleGraphBase &) = delete;
  PrintHWModuleGraphBase(PrintHWModuleGraphBase &&) = delete;
  PrintHWModuleGraphBase& operator=(PrintHWModuleGraphBase &&) = delete;
  ~PrintHWModuleGraphBase() = default;

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("hw-print-module-graph");
  }
  ::llvm::StringRef getArgument() const override { return "hw-print-module-graph"; }

  ::llvm::StringRef getDescription() const override { return "Print a DOT graph of the HWModule's within a top-level module."; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("PrintHWModuleGraph");
  }
  ::llvm::StringRef getName() const override { return "PrintHWModuleGraph"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Register the dialects that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    
  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(PrintHWModuleGraphBase<DerivedT>)

protected:
  ::mlir::Pass::Option<bool> verboseEdges{*this, "verbose-edges", ::llvm::cl::desc("Print information on SSA edges (types, operand #, ...)"), ::llvm::cl::init(false)};
};

template <typename DerivedT>
class PrintInstanceGraphBase : public ::mlir::OperationPass<mlir::ModuleOp> {
public:
  using Base = PrintInstanceGraphBase;

  PrintInstanceGraphBase() : ::mlir::OperationPass<mlir::ModuleOp>(::mlir::TypeID::get<DerivedT>()) {}
  PrintInstanceGraphBase(const PrintInstanceGraphBase &other) : ::mlir::OperationPass<mlir::ModuleOp>(other) {}
  PrintInstanceGraphBase& operator=(const PrintInstanceGraphBase &) = delete;
  PrintInstanceGraphBase(PrintInstanceGraphBase &&) = delete;
  PrintInstanceGraphBase& operator=(PrintInstanceGraphBase &&) = delete;
  ~PrintInstanceGraphBase() = default;

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("hw-print-instance-graph");
  }
  ::llvm::StringRef getArgument() const override { return "hw-print-instance-graph"; }

  ::llvm::StringRef getDescription() const override { return "Print a DOT graph of the module hierarchy."; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("PrintInstanceGraph");
  }
  ::llvm::StringRef getName() const override { return "PrintInstanceGraph"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Register the dialects that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    
  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(PrintInstanceGraphBase<DerivedT>)

protected:
};

template <typename DerivedT>
class VerifyInnerRefNamespaceBase : public ::mlir::OperationPass<> {
public:
  using Base = VerifyInnerRefNamespaceBase;

  VerifyInnerRefNamespaceBase() : ::mlir::OperationPass<>(::mlir::TypeID::get<DerivedT>()) {}
  VerifyInnerRefNamespaceBase(const VerifyInnerRefNamespaceBase &other) : ::mlir::OperationPass<>(other) {}
  VerifyInnerRefNamespaceBase& operator=(const VerifyInnerRefNamespaceBase &) = delete;
  VerifyInnerRefNamespaceBase(VerifyInnerRefNamespaceBase &&) = delete;
  VerifyInnerRefNamespaceBase& operator=(VerifyInnerRefNamespaceBase &&) = delete;
  ~VerifyInnerRefNamespaceBase() = default;

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("hw-verify-irn");
  }
  ::llvm::StringRef getArgument() const override { return "hw-verify-irn"; }

  ::llvm::StringRef getDescription() const override { return "Verify InnerRefNamespaceLike operations, if not self-verifying."; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("VerifyInnerRefNamespace");
  }
  ::llvm::StringRef getName() const override { return "VerifyInnerRefNamespace"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Register the dialects that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    
  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(VerifyInnerRefNamespaceBase<DerivedT>)

protected:
};
#undef GEN_PASS_CLASSES
#endif // GEN_PASS_CLASSES
