/*===- TableGen'erated file -------------------------------------*- C++ -*-===*\
|*                                                                            *|
|* Enum Utility Definitions                                                   *|
|*                                                                            *|
|* Automatically generated file, do not edit!                                 *|
|* From: Moore.td                                                             *|
|*                                                                            *|
\*===----------------------------------------------------------------------===*/

namespace circt {
namespace moore {
::llvm::StringRef stringifyEdge(Edge val) {
  switch (val) {
    case Edge::None: return "none";
    case Edge::PosEdge: return "posedge";
    case Edge::NegEdge: return "negedge";
    case Edge::BothEdges: return "edge";
  }
  return "";
}

::std::optional<Edge> symbolizeEdge(::llvm::StringRef str) {
  return ::llvm::StringSwitch<::std::optional<Edge>>(str)
      .Case("none", Edge::None)
      .Case("posedge", Edge::PosEdge)
      .Case("negedge", Edge::NegEdge)
      .Case("edge", Edge::BothEdges)
      .Default(::std::nullopt);
}
::std::optional<Edge> symbolizeEdge(uint32_t value) {
  switch (value) {
  case 0: return Edge::None;
  case 1: return Edge::PosEdge;
  case 2: return Edge::NegEdge;
  case 3: return Edge::BothEdges;
  default: return ::std::nullopt;
  }
}

bool EdgeAttr::classof(::mlir::Attribute attr) {
  return (((::llvm::isa<::mlir::IntegerAttr>(attr))) && ((::llvm::cast<::mlir::IntegerAttr>(attr).getType().isSignlessInteger(32)))) && (((::llvm::cast<::mlir::IntegerAttr>(attr).getInt() == 0)) || ((::llvm::cast<::mlir::IntegerAttr>(attr).getInt() == 1)) || ((::llvm::cast<::mlir::IntegerAttr>(attr).getInt() == 2)) || ((::llvm::cast<::mlir::IntegerAttr>(attr).getInt() == 3)));
}
EdgeAttr EdgeAttr::get(::mlir::MLIRContext *context, Edge val) {
  ::mlir::IntegerType intType = ::mlir::IntegerType::get(context, 32);
  ::mlir::IntegerAttr baseAttr = ::mlir::IntegerAttr::get(intType, static_cast<uint32_t>(val));
  return ::llvm::cast<EdgeAttr>(baseAttr);
}
Edge EdgeAttr::getValue() const {
  return static_cast<Edge>(::mlir::IntegerAttr::getInt());
}
} // namespace moore
} // namespace circt

namespace circt {
namespace moore {
::llvm::StringRef stringifyNamedConst(NamedConst val) {
  switch (val) {
    case NamedConst::Parameter: return "parameter";
    case NamedConst::LocalParameter: return "localparam";
    case NamedConst::SpecParameter: return "specparam";
  }
  return "";
}

::std::optional<NamedConst> symbolizeNamedConst(::llvm::StringRef str) {
  return ::llvm::StringSwitch<::std::optional<NamedConst>>(str)
      .Case("parameter", NamedConst::Parameter)
      .Case("localparam", NamedConst::LocalParameter)
      .Case("specparam", NamedConst::SpecParameter)
      .Default(::std::nullopt);
}
::std::optional<NamedConst> symbolizeNamedConst(uint32_t value) {
  switch (value) {
  case 0: return NamedConst::Parameter;
  case 1: return NamedConst::LocalParameter;
  case 2: return NamedConst::SpecParameter;
  default: return ::std::nullopt;
  }
}

bool NamedConstAttr::classof(::mlir::Attribute attr) {
  return (((::llvm::isa<::mlir::IntegerAttr>(attr))) && ((::llvm::cast<::mlir::IntegerAttr>(attr).getType().isSignlessInteger(32)))) && (((::llvm::cast<::mlir::IntegerAttr>(attr).getInt() == 0)) || ((::llvm::cast<::mlir::IntegerAttr>(attr).getInt() == 1)) || ((::llvm::cast<::mlir::IntegerAttr>(attr).getInt() == 2)));
}
NamedConstAttr NamedConstAttr::get(::mlir::MLIRContext *context, NamedConst val) {
  ::mlir::IntegerType intType = ::mlir::IntegerType::get(context, 32);
  ::mlir::IntegerAttr baseAttr = ::mlir::IntegerAttr::get(intType, static_cast<uint32_t>(val));
  return ::llvm::cast<NamedConstAttr>(baseAttr);
}
NamedConst NamedConstAttr::getValue() const {
  return static_cast<NamedConst>(::mlir::IntegerAttr::getInt());
}
} // namespace moore
} // namespace circt

namespace circt {
namespace moore {
::llvm::StringRef stringifyNetKind(NetKind val) {
  switch (val) {
    case NetKind::Supply0: return "supply0";
    case NetKind::Supply1: return "supply1";
    case NetKind::Tri: return "tri";
    case NetKind::TriAnd: return "triand";
    case NetKind::TriOr: return "trior";
    case NetKind::TriReg: return "trireg";
    case NetKind::Tri0: return "tri0";
    case NetKind::Tri1: return "tri1";
    case NetKind::UWire: return "uwire";
    case NetKind::Wire: return "wire";
    case NetKind::WAnd: return "wand";
    case NetKind::WOr: return "wor";
    case NetKind::Interconnect: return "interconnect";
    case NetKind::UserDefined: return "userdefined";
    case NetKind::Unknown: return "unknown";
  }
  return "";
}

::std::optional<NetKind> symbolizeNetKind(::llvm::StringRef str) {
  return ::llvm::StringSwitch<::std::optional<NetKind>>(str)
      .Case("supply0", NetKind::Supply0)
      .Case("supply1", NetKind::Supply1)
      .Case("tri", NetKind::Tri)
      .Case("triand", NetKind::TriAnd)
      .Case("trior", NetKind::TriOr)
      .Case("trireg", NetKind::TriReg)
      .Case("tri0", NetKind::Tri0)
      .Case("tri1", NetKind::Tri1)
      .Case("uwire", NetKind::UWire)
      .Case("wire", NetKind::Wire)
      .Case("wand", NetKind::WAnd)
      .Case("wor", NetKind::WOr)
      .Case("interconnect", NetKind::Interconnect)
      .Case("userdefined", NetKind::UserDefined)
      .Case("unknown", NetKind::Unknown)
      .Default(::std::nullopt);
}
::std::optional<NetKind> symbolizeNetKind(uint32_t value) {
  switch (value) {
  case 0: return NetKind::Supply0;
  case 1: return NetKind::Supply1;
  case 2: return NetKind::Tri;
  case 3: return NetKind::TriAnd;
  case 4: return NetKind::TriOr;
  case 5: return NetKind::TriReg;
  case 6: return NetKind::Tri0;
  case 7: return NetKind::Tri1;
  case 8: return NetKind::UWire;
  case 9: return NetKind::Wire;
  case 10: return NetKind::WAnd;
  case 11: return NetKind::WOr;
  case 12: return NetKind::Interconnect;
  case 13: return NetKind::UserDefined;
  case 14: return NetKind::Unknown;
  default: return ::std::nullopt;
  }
}

bool NetKindAttr::classof(::mlir::Attribute attr) {
  return (((::llvm::isa<::mlir::IntegerAttr>(attr))) && ((::llvm::cast<::mlir::IntegerAttr>(attr).getType().isSignlessInteger(32)))) && (((::llvm::cast<::mlir::IntegerAttr>(attr).getInt() == 0)) || ((::llvm::cast<::mlir::IntegerAttr>(attr).getInt() == 1)) || ((::llvm::cast<::mlir::IntegerAttr>(attr).getInt() == 2)) || ((::llvm::cast<::mlir::IntegerAttr>(attr).getInt() == 3)) || ((::llvm::cast<::mlir::IntegerAttr>(attr).getInt() == 4)) || ((::llvm::cast<::mlir::IntegerAttr>(attr).getInt() == 5)) || ((::llvm::cast<::mlir::IntegerAttr>(attr).getInt() == 6)) || ((::llvm::cast<::mlir::IntegerAttr>(attr).getInt() == 7)) || ((::llvm::cast<::mlir::IntegerAttr>(attr).getInt() == 8)) || ((::llvm::cast<::mlir::IntegerAttr>(attr).getInt() == 9)) || ((::llvm::cast<::mlir::IntegerAttr>(attr).getInt() == 10)) || ((::llvm::cast<::mlir::IntegerAttr>(attr).getInt() == 11)) || ((::llvm::cast<::mlir::IntegerAttr>(attr).getInt() == 12)) || ((::llvm::cast<::mlir::IntegerAttr>(attr).getInt() == 13)) || ((::llvm::cast<::mlir::IntegerAttr>(attr).getInt() == 14)));
}
NetKindAttr NetKindAttr::get(::mlir::MLIRContext *context, NetKind val) {
  ::mlir::IntegerType intType = ::mlir::IntegerType::get(context, 32);
  ::mlir::IntegerAttr baseAttr = ::mlir::IntegerAttr::get(intType, static_cast<uint32_t>(val));
  return ::llvm::cast<NetKindAttr>(baseAttr);
}
NetKind NetKindAttr::getValue() const {
  return static_cast<NetKind>(::mlir::IntegerAttr::getInt());
}
} // namespace moore
} // namespace circt

namespace circt {
namespace moore {
::llvm::StringRef stringifyProcedureKind(ProcedureKind val) {
  switch (val) {
    case ProcedureKind::Initial: return "initial";
    case ProcedureKind::Final: return "final";
    case ProcedureKind::Always: return "always";
    case ProcedureKind::AlwaysComb: return "always_comb";
    case ProcedureKind::AlwaysLatch: return "always_latch";
    case ProcedureKind::AlwaysFF: return "always_ff";
  }
  return "";
}

::std::optional<ProcedureKind> symbolizeProcedureKind(::llvm::StringRef str) {
  return ::llvm::StringSwitch<::std::optional<ProcedureKind>>(str)
      .Case("initial", ProcedureKind::Initial)
      .Case("final", ProcedureKind::Final)
      .Case("always", ProcedureKind::Always)
      .Case("always_comb", ProcedureKind::AlwaysComb)
      .Case("always_latch", ProcedureKind::AlwaysLatch)
      .Case("always_ff", ProcedureKind::AlwaysFF)
      .Default(::std::nullopt);
}
::std::optional<ProcedureKind> symbolizeProcedureKind(uint32_t value) {
  switch (value) {
  case 0: return ProcedureKind::Initial;
  case 1: return ProcedureKind::Final;
  case 2: return ProcedureKind::Always;
  case 3: return ProcedureKind::AlwaysComb;
  case 4: return ProcedureKind::AlwaysLatch;
  case 5: return ProcedureKind::AlwaysFF;
  default: return ::std::nullopt;
  }
}

bool ProcedureKindAttr::classof(::mlir::Attribute attr) {
  return (((::llvm::isa<::mlir::IntegerAttr>(attr))) && ((::llvm::cast<::mlir::IntegerAttr>(attr).getType().isSignlessInteger(32)))) && (((::llvm::cast<::mlir::IntegerAttr>(attr).getInt() == 0)) || ((::llvm::cast<::mlir::IntegerAttr>(attr).getInt() == 1)) || ((::llvm::cast<::mlir::IntegerAttr>(attr).getInt() == 2)) || ((::llvm::cast<::mlir::IntegerAttr>(attr).getInt() == 3)) || ((::llvm::cast<::mlir::IntegerAttr>(attr).getInt() == 4)) || ((::llvm::cast<::mlir::IntegerAttr>(attr).getInt() == 5)));
}
ProcedureKindAttr ProcedureKindAttr::get(::mlir::MLIRContext *context, ProcedureKind val) {
  ::mlir::IntegerType intType = ::mlir::IntegerType::get(context, 32);
  ::mlir::IntegerAttr baseAttr = ::mlir::IntegerAttr::get(intType, static_cast<uint32_t>(val));
  return ::llvm::cast<ProcedureKindAttr>(baseAttr);
}
ProcedureKind ProcedureKindAttr::getValue() const {
  return static_cast<ProcedureKind>(::mlir::IntegerAttr::getInt());
}
} // namespace moore
} // namespace circt

