/*===- TableGen'erated file -------------------------------------*- C++ -*-===*\
|*                                                                            *|
|* Enum Utility Declarations                                                  *|
|*                                                                            *|
|* Automatically generated file, do not edit!                                 *|
|* From: Moore.td                                                             *|
|*                                                                            *|
\*===----------------------------------------------------------------------===*/

namespace circt {
namespace moore {
// Edge kind
enum class Edge : uint32_t {
  None = 0,
  PosEdge = 1,
  NegEdge = 2,
  BothEdges = 3,
};

::std::optional<Edge> symbolizeEdge(uint32_t);
::llvm::StringRef stringifyEdge(Edge);
::std::optional<Edge> symbolizeEdge(::llvm::StringRef);
inline constexpr unsigned getMaxEnumValForEdge() {
  return 3;
}


inline ::llvm::StringRef stringifyEnum(Edge enumValue) {
  return stringifyEdge(enumValue);
}

template <typename EnumType>
::std::optional<EnumType> symbolizeEnum(::llvm::StringRef);

template <>
inline ::std::optional<Edge> symbolizeEnum<Edge>(::llvm::StringRef str) {
  return symbolizeEdge(str);
}

class EdgeAttr : public ::mlir::IntegerAttr {
public:
  using ValueType = Edge;
  using ::mlir::IntegerAttr::IntegerAttr;
  static bool classof(::mlir::Attribute attr);
  static EdgeAttr get(::mlir::MLIRContext *context, Edge val);
  Edge getValue() const;
};
} // namespace moore
} // namespace circt

namespace mlir {
template <typename T, typename>
struct FieldParser;

template<>
struct FieldParser<circt::moore::Edge, circt::moore::Edge> {
  template <typename ParserT>
  static FailureOr<circt::moore::Edge> parse(ParserT &parser) {
    // Parse the keyword/string containing the enum.
    std::string enumKeyword;
    auto loc = parser.getCurrentLocation();
    if (failed(parser.parseOptionalKeywordOrString(&enumKeyword)))
      return parser.emitError(loc, "expected keyword for Edge kind");

    // Symbolize the keyword.
    if (::std::optional<circt::moore::Edge> attr = circt::moore::symbolizeEnum<circt::moore::Edge>(enumKeyword))
      return *attr;
    return parser.emitError(loc, "invalid Edge kind specification: ") << enumKeyword;
  }
};
} // namespace mlir

namespace llvm {
inline ::llvm::raw_ostream &operator<<(::llvm::raw_ostream &p, circt::moore::Edge value) {
  auto valueStr = stringifyEnum(value);
  return p << valueStr;
}
} // namespace llvm

namespace llvm {
template<> struct DenseMapInfo<circt::moore::Edge> {
  using StorageInfo = ::llvm::DenseMapInfo<uint32_t>;

  static inline circt::moore::Edge getEmptyKey() {
    return static_cast<circt::moore::Edge>(StorageInfo::getEmptyKey());
  }

  static inline circt::moore::Edge getTombstoneKey() {
    return static_cast<circt::moore::Edge>(StorageInfo::getTombstoneKey());
  }

  static unsigned getHashValue(const circt::moore::Edge &val) {
    return StorageInfo::getHashValue(static_cast<uint32_t>(val));
  }

  static bool isEqual(const circt::moore::Edge &lhs, const circt::moore::Edge &rhs) {
    return lhs == rhs;
  }
};
}

namespace circt {
namespace moore {
// elaboration-time constants
enum class NamedConst : uint32_t {
  Parameter = 0,
  LocalParameter = 1,
  SpecParameter = 2,
};

::std::optional<NamedConst> symbolizeNamedConst(uint32_t);
::llvm::StringRef stringifyNamedConst(NamedConst);
::std::optional<NamedConst> symbolizeNamedConst(::llvm::StringRef);
inline constexpr unsigned getMaxEnumValForNamedConst() {
  return 2;
}


inline ::llvm::StringRef stringifyEnum(NamedConst enumValue) {
  return stringifyNamedConst(enumValue);
}

template <typename EnumType>
::std::optional<EnumType> symbolizeEnum(::llvm::StringRef);

template <>
inline ::std::optional<NamedConst> symbolizeEnum<NamedConst>(::llvm::StringRef str) {
  return symbolizeNamedConst(str);
}

class NamedConstAttr : public ::mlir::IntegerAttr {
public:
  using ValueType = NamedConst;
  using ::mlir::IntegerAttr::IntegerAttr;
  static bool classof(::mlir::Attribute attr);
  static NamedConstAttr get(::mlir::MLIRContext *context, NamedConst val);
  NamedConst getValue() const;
};
} // namespace moore
} // namespace circt

namespace mlir {
template <typename T, typename>
struct FieldParser;

template<>
struct FieldParser<circt::moore::NamedConst, circt::moore::NamedConst> {
  template <typename ParserT>
  static FailureOr<circt::moore::NamedConst> parse(ParserT &parser) {
    // Parse the keyword/string containing the enum.
    std::string enumKeyword;
    auto loc = parser.getCurrentLocation();
    if (failed(parser.parseOptionalKeywordOrString(&enumKeyword)))
      return parser.emitError(loc, "expected keyword for elaboration-time constants");

    // Symbolize the keyword.
    if (::std::optional<circt::moore::NamedConst> attr = circt::moore::symbolizeEnum<circt::moore::NamedConst>(enumKeyword))
      return *attr;
    return parser.emitError(loc, "invalid elaboration-time constants specification: ") << enumKeyword;
  }
};
} // namespace mlir

namespace llvm {
inline ::llvm::raw_ostream &operator<<(::llvm::raw_ostream &p, circt::moore::NamedConst value) {
  auto valueStr = stringifyEnum(value);
  return p << valueStr;
}
} // namespace llvm

namespace llvm {
template<> struct DenseMapInfo<circt::moore::NamedConst> {
  using StorageInfo = ::llvm::DenseMapInfo<uint32_t>;

  static inline circt::moore::NamedConst getEmptyKey() {
    return static_cast<circt::moore::NamedConst>(StorageInfo::getEmptyKey());
  }

  static inline circt::moore::NamedConst getTombstoneKey() {
    return static_cast<circt::moore::NamedConst>(StorageInfo::getTombstoneKey());
  }

  static unsigned getHashValue(const circt::moore::NamedConst &val) {
    return StorageInfo::getHashValue(static_cast<uint32_t>(val));
  }

  static bool isEqual(const circt::moore::NamedConst &lhs, const circt::moore::NamedConst &rhs) {
    return lhs == rhs;
  }
};
}

namespace circt {
namespace moore {
// Net type kind
enum class NetKind : uint32_t {
  Supply0 = 0,
  Supply1 = 1,
  Tri = 2,
  TriAnd = 3,
  TriOr = 4,
  TriReg = 5,
  Tri0 = 6,
  Tri1 = 7,
  UWire = 8,
  Wire = 9,
  WAnd = 10,
  WOr = 11,
  Interconnect = 12,
  UserDefined = 13,
  Unknown = 14,
};

::std::optional<NetKind> symbolizeNetKind(uint32_t);
::llvm::StringRef stringifyNetKind(NetKind);
::std::optional<NetKind> symbolizeNetKind(::llvm::StringRef);
inline constexpr unsigned getMaxEnumValForNetKind() {
  return 14;
}


inline ::llvm::StringRef stringifyEnum(NetKind enumValue) {
  return stringifyNetKind(enumValue);
}

template <typename EnumType>
::std::optional<EnumType> symbolizeEnum(::llvm::StringRef);

template <>
inline ::std::optional<NetKind> symbolizeEnum<NetKind>(::llvm::StringRef str) {
  return symbolizeNetKind(str);
}

class NetKindAttr : public ::mlir::IntegerAttr {
public:
  using ValueType = NetKind;
  using ::mlir::IntegerAttr::IntegerAttr;
  static bool classof(::mlir::Attribute attr);
  static NetKindAttr get(::mlir::MLIRContext *context, NetKind val);
  NetKind getValue() const;
};
} // namespace moore
} // namespace circt

namespace mlir {
template <typename T, typename>
struct FieldParser;

template<>
struct FieldParser<::circt::moore::NetKind, ::circt::moore::NetKind> {
  template <typename ParserT>
  static FailureOr<::circt::moore::NetKind> parse(ParserT &parser) {
    // Parse the keyword/string containing the enum.
    std::string enumKeyword;
    auto loc = parser.getCurrentLocation();
    if (failed(parser.parseOptionalKeywordOrString(&enumKeyword)))
      return parser.emitError(loc, "expected keyword for Net type kind");

    // Symbolize the keyword.
    if (::std::optional<::circt::moore::NetKind> attr = ::circt::moore::symbolizeEnum<::circt::moore::NetKind>(enumKeyword))
      return *attr;
    return parser.emitError(loc, "invalid Net type kind specification: ") << enumKeyword;
  }
};
} // namespace mlir

namespace llvm {
inline ::llvm::raw_ostream &operator<<(::llvm::raw_ostream &p, ::circt::moore::NetKind value) {
  auto valueStr = stringifyEnum(value);
  return p << valueStr;
}
} // namespace llvm

namespace llvm {
template<> struct DenseMapInfo<::circt::moore::NetKind> {
  using StorageInfo = ::llvm::DenseMapInfo<uint32_t>;

  static inline ::circt::moore::NetKind getEmptyKey() {
    return static_cast<::circt::moore::NetKind>(StorageInfo::getEmptyKey());
  }

  static inline ::circt::moore::NetKind getTombstoneKey() {
    return static_cast<::circt::moore::NetKind>(StorageInfo::getTombstoneKey());
  }

  static unsigned getHashValue(const ::circt::moore::NetKind &val) {
    return StorageInfo::getHashValue(static_cast<uint32_t>(val));
  }

  static bool isEqual(const ::circt::moore::NetKind &lhs, const ::circt::moore::NetKind &rhs) {
    return lhs == rhs;
  }
};
}

namespace circt {
namespace moore {
// Procedure kind
enum class ProcedureKind : uint32_t {
  Initial = 0,
  Final = 1,
  Always = 2,
  AlwaysComb = 3,
  AlwaysLatch = 4,
  AlwaysFF = 5,
};

::std::optional<ProcedureKind> symbolizeProcedureKind(uint32_t);
::llvm::StringRef stringifyProcedureKind(ProcedureKind);
::std::optional<ProcedureKind> symbolizeProcedureKind(::llvm::StringRef);
inline constexpr unsigned getMaxEnumValForProcedureKind() {
  return 5;
}


inline ::llvm::StringRef stringifyEnum(ProcedureKind enumValue) {
  return stringifyProcedureKind(enumValue);
}

template <typename EnumType>
::std::optional<EnumType> symbolizeEnum(::llvm::StringRef);

template <>
inline ::std::optional<ProcedureKind> symbolizeEnum<ProcedureKind>(::llvm::StringRef str) {
  return symbolizeProcedureKind(str);
}

class ProcedureKindAttr : public ::mlir::IntegerAttr {
public:
  using ValueType = ProcedureKind;
  using ::mlir::IntegerAttr::IntegerAttr;
  static bool classof(::mlir::Attribute attr);
  static ProcedureKindAttr get(::mlir::MLIRContext *context, ProcedureKind val);
  ProcedureKind getValue() const;
};
} // namespace moore
} // namespace circt

namespace mlir {
template <typename T, typename>
struct FieldParser;

template<>
struct FieldParser<circt::moore::ProcedureKind, circt::moore::ProcedureKind> {
  template <typename ParserT>
  static FailureOr<circt::moore::ProcedureKind> parse(ParserT &parser) {
    // Parse the keyword/string containing the enum.
    std::string enumKeyword;
    auto loc = parser.getCurrentLocation();
    if (failed(parser.parseOptionalKeywordOrString(&enumKeyword)))
      return parser.emitError(loc, "expected keyword for Procedure kind");

    // Symbolize the keyword.
    if (::std::optional<circt::moore::ProcedureKind> attr = circt::moore::symbolizeEnum<circt::moore::ProcedureKind>(enumKeyword))
      return *attr;
    return parser.emitError(loc, "invalid Procedure kind specification: ") << enumKeyword;
  }
};
} // namespace mlir

namespace llvm {
inline ::llvm::raw_ostream &operator<<(::llvm::raw_ostream &p, circt::moore::ProcedureKind value) {
  auto valueStr = stringifyEnum(value);
  return p << valueStr;
}
} // namespace llvm

namespace llvm {
template<> struct DenseMapInfo<circt::moore::ProcedureKind> {
  using StorageInfo = ::llvm::DenseMapInfo<uint32_t>;

  static inline circt::moore::ProcedureKind getEmptyKey() {
    return static_cast<circt::moore::ProcedureKind>(StorageInfo::getEmptyKey());
  }

  static inline circt::moore::ProcedureKind getTombstoneKey() {
    return static_cast<circt::moore::ProcedureKind>(StorageInfo::getTombstoneKey());
  }

  static unsigned getHashValue(const circt::moore::ProcedureKind &val) {
    return StorageInfo::getHashValue(static_cast<uint32_t>(val));
  }

  static bool isEqual(const circt::moore::ProcedureKind &lhs, const circt::moore::ProcedureKind &rhs) {
    return lhs == rhs;
  }
};
}

