/*===- TableGen'erated file -------------------------------------*- C++ -*-===*\
|*                                                                            *|
|* TypeDef Declarations                                                       *|
|*                                                                            *|
|* Automatically generated file, do not edit!                                 *|
|*                                                                            *|
\*===----------------------------------------------------------------------===*/

#ifdef GET_TYPEDEF_CLASSES
#undef GET_TYPEDEF_CLASSES


namespace mlir {
class AsmParser;
class AsmPrinter;
} // namespace mlir
namespace circt {
namespace moore {
class VoidType;
class StringType;
class ChandleType;
class EventType;
class IntType;
class RealType;
class ArrayType;
class UnpackedArrayType;
class OpenArrayType;
class OpenUnpackedArrayType;
class AssocArrayType;
class QueueType;
class StructType;
class UnpackedStructType;
class UnionType;
class UnpackedUnionType;
class RefType;
class VoidType : public ::mlir::Type::TypeBase<VoidType, moore::PackedType, ::mlir::TypeStorage> {
public:
  using Base::Base;
  static constexpr ::llvm::StringLiteral name = "moore.void";
  static constexpr ::llvm::StringLiteral dialectName = "moore";
  static constexpr ::llvm::StringLiteral getMnemonic() {
    return {"void"};
  }

};
class StringType : public ::mlir::Type::TypeBase<StringType, moore::UnpackedType, ::mlir::TypeStorage> {
public:
  using Base::Base;
  static constexpr ::llvm::StringLiteral name = "moore.string";
  static constexpr ::llvm::StringLiteral dialectName = "moore";
  static constexpr ::llvm::StringLiteral getMnemonic() {
    return {"string"};
  }

};
class ChandleType : public ::mlir::Type::TypeBase<ChandleType, moore::UnpackedType, ::mlir::TypeStorage> {
public:
  using Base::Base;
  static constexpr ::llvm::StringLiteral name = "moore.chandle";
  static constexpr ::llvm::StringLiteral dialectName = "moore";
  static constexpr ::llvm::StringLiteral getMnemonic() {
    return {"chandle"};
  }

};
class EventType : public ::mlir::Type::TypeBase<EventType, moore::UnpackedType, ::mlir::TypeStorage> {
public:
  using Base::Base;
  static constexpr ::llvm::StringLiteral name = "moore.event";
  static constexpr ::llvm::StringLiteral dialectName = "moore";
  static constexpr ::llvm::StringLiteral getMnemonic() {
    return {"event"};
  }

};
namespace detail {
struct IntTypeStorage;
} // namespace detail
class IntType : public ::mlir::Type::TypeBase<IntType, moore::PackedType, detail::IntTypeStorage> {
public:
  using Base::Base;
  /// Create a signless `bit [width-1:0]` type.
  static IntType getInt(MLIRContext *context, unsigned width) {
    return get(context, width, Domain::TwoValued);
  }

  /// Create a signless `logic [width-1:0]` type.
  static IntType getLogic(MLIRContext *context, unsigned width) {
    return get(context, width, Domain::FourValued);
  }
  static constexpr ::llvm::StringLiteral name = "moore.int";
  static constexpr ::llvm::StringLiteral dialectName = "moore";
  static IntType get(::mlir::MLIRContext *context, unsigned width, Domain domain);
  unsigned getWidth() const;
  Domain getDomain() const;
};
class RealType : public ::mlir::Type::TypeBase<RealType, moore::UnpackedType, ::mlir::TypeStorage> {
public:
  using Base::Base;
  static constexpr ::llvm::StringLiteral name = "moore.real";
  static constexpr ::llvm::StringLiteral dialectName = "moore";
  static constexpr ::llvm::StringLiteral getMnemonic() {
    return {"real"};
  }

};
namespace detail {
struct ArrayTypeStorage;
} // namespace detail
class ArrayType : public ::mlir::Type::TypeBase<ArrayType, moore::PackedType, detail::ArrayTypeStorage> {
public:
  using Base::Base;
  static constexpr ::llvm::StringLiteral name = "moore.array";
  static constexpr ::llvm::StringLiteral dialectName = "moore";
  static ArrayType get(::mlir::MLIRContext *context, unsigned size, PackedType elementType);
  static ArrayType get(unsigned size, PackedType elementType);
  static constexpr ::llvm::StringLiteral getMnemonic() {
    return {"array"};
  }

  static ::mlir::Type parse(::mlir::AsmParser &odsParser);
  void print(::mlir::AsmPrinter &odsPrinter) const;
  unsigned getSize() const;
  PackedType getElementType() const;
};
namespace detail {
struct UnpackedArrayTypeStorage;
} // namespace detail
class UnpackedArrayType : public ::mlir::Type::TypeBase<UnpackedArrayType, moore::UnpackedType, detail::UnpackedArrayTypeStorage> {
public:
  using Base::Base;
  static constexpr ::llvm::StringLiteral name = "moore.uarray";
  static constexpr ::llvm::StringLiteral dialectName = "moore";
  static UnpackedArrayType get(::mlir::MLIRContext *context, unsigned size, UnpackedType elementType);
  static UnpackedArrayType get(unsigned size, UnpackedType elementType);
  static constexpr ::llvm::StringLiteral getMnemonic() {
    return {"uarray"};
  }

  static ::mlir::Type parse(::mlir::AsmParser &odsParser);
  void print(::mlir::AsmPrinter &odsPrinter) const;
  unsigned getSize() const;
  UnpackedType getElementType() const;
};
namespace detail {
struct OpenArrayTypeStorage;
} // namespace detail
class OpenArrayType : public ::mlir::Type::TypeBase<OpenArrayType, moore::PackedType, detail::OpenArrayTypeStorage> {
public:
  using Base::Base;
  static constexpr ::llvm::StringLiteral name = "moore.open_array";
  static constexpr ::llvm::StringLiteral dialectName = "moore";
  static OpenArrayType get(::mlir::MLIRContext *context, PackedType elementType);
  static OpenArrayType get(PackedType elementType);
  static constexpr ::llvm::StringLiteral getMnemonic() {
    return {"open_array"};
  }

  static ::mlir::Type parse(::mlir::AsmParser &odsParser);
  void print(::mlir::AsmPrinter &odsPrinter) const;
  PackedType getElementType() const;
};
namespace detail {
struct OpenUnpackedArrayTypeStorage;
} // namespace detail
class OpenUnpackedArrayType : public ::mlir::Type::TypeBase<OpenUnpackedArrayType, moore::UnpackedType, detail::OpenUnpackedArrayTypeStorage> {
public:
  using Base::Base;
  static constexpr ::llvm::StringLiteral name = "moore.open_uarray";
  static constexpr ::llvm::StringLiteral dialectName = "moore";
  static OpenUnpackedArrayType get(::mlir::MLIRContext *context, UnpackedType elementType);
  static OpenUnpackedArrayType get(UnpackedType elementType);
  static constexpr ::llvm::StringLiteral getMnemonic() {
    return {"open_uarray"};
  }

  static ::mlir::Type parse(::mlir::AsmParser &odsParser);
  void print(::mlir::AsmPrinter &odsPrinter) const;
  UnpackedType getElementType() const;
};
namespace detail {
struct AssocArrayTypeStorage;
} // namespace detail
class AssocArrayType : public ::mlir::Type::TypeBase<AssocArrayType, moore::UnpackedType, detail::AssocArrayTypeStorage> {
public:
  using Base::Base;
  static constexpr ::llvm::StringLiteral name = "moore.assoc_array";
  static constexpr ::llvm::StringLiteral dialectName = "moore";
  static AssocArrayType get(::mlir::MLIRContext *context, UnpackedType elementType, UnpackedType indexType);
  static AssocArrayType get(UnpackedType elementType, UnpackedType indexType);
  static constexpr ::llvm::StringLiteral getMnemonic() {
    return {"assoc_array"};
  }

  static ::mlir::Type parse(::mlir::AsmParser &odsParser);
  void print(::mlir::AsmPrinter &odsPrinter) const;
  UnpackedType getElementType() const;
  UnpackedType getIndexType() const;
};
namespace detail {
struct QueueTypeStorage;
} // namespace detail
class QueueType : public ::mlir::Type::TypeBase<QueueType, moore::UnpackedType, detail::QueueTypeStorage> {
public:
  using Base::Base;
  static constexpr ::llvm::StringLiteral name = "moore.queue";
  static constexpr ::llvm::StringLiteral dialectName = "moore";
  static QueueType get(::mlir::MLIRContext *context, UnpackedType elementType, unsigned bound);
  static QueueType get(UnpackedType elementType, unsigned bound);
  static constexpr ::llvm::StringLiteral getMnemonic() {
    return {"queue"};
  }

  static ::mlir::Type parse(::mlir::AsmParser &odsParser);
  void print(::mlir::AsmPrinter &odsPrinter) const;
  UnpackedType getElementType() const;
  unsigned getBound() const;
};
namespace detail {
struct StructTypeStorage;
} // namespace detail
class StructType : public ::mlir::Type::TypeBase<StructType, moore::PackedType, detail::StructTypeStorage, ::mlir::DestructurableTypeInterface::Trait> {
public:
  using Base::Base;
  std::optional<DenseMap<Attribute, Type>> getSubelementIndexMap();
  Type getTypeAtIndex(Attribute index);
  std::optional<uint32_t> getFieldIndex(StringAttr nameField);
  static constexpr ::llvm::StringLiteral name = "moore.struct";
  static constexpr ::llvm::StringLiteral dialectName = "moore";
  using Base::getChecked;
  static StructType get(::mlir::MLIRContext *context, ::llvm::ArrayRef<StructLikeMember> members);
  static StructType getChecked(::llvm::function_ref<::mlir::InFlightDiagnostic()> emitError, ::mlir::MLIRContext *context, ::llvm::ArrayRef<StructLikeMember> members);
  static ::llvm::LogicalResult verify(::llvm::function_ref<::mlir::InFlightDiagnostic()> emitError, ::llvm::ArrayRef<StructLikeMember> members);
  static constexpr ::llvm::StringLiteral getMnemonic() {
    return {"struct"};
  }

  static ::mlir::Type parse(::mlir::AsmParser &odsParser);
  void print(::mlir::AsmPrinter &odsPrinter) const;
  ::llvm::ArrayRef<StructLikeMember> getMembers() const;
  ::std::optional<::llvm::DenseMap<::mlir::Attribute, ::mlir::Type>> getSubelementIndexMap() const;
  ::mlir::Type getTypeAtIndex(::mlir::Attribute index) const;
};
namespace detail {
struct UnpackedStructTypeStorage;
} // namespace detail
class UnpackedStructType : public ::mlir::Type::TypeBase<UnpackedStructType, moore::UnpackedType, detail::UnpackedStructTypeStorage, ::mlir::DestructurableTypeInterface::Trait> {
public:
  using Base::Base;
  std::optional<DenseMap<Attribute, Type>> getSubelementIndexMap();
  Type getTypeAtIndex(Attribute index);
  std::optional<uint32_t> getFieldIndex(StringAttr nameField);
  static constexpr ::llvm::StringLiteral name = "moore.ustruct";
  static constexpr ::llvm::StringLiteral dialectName = "moore";
  static UnpackedStructType get(::mlir::MLIRContext *context, ::llvm::ArrayRef<StructLikeMember> members);
  static constexpr ::llvm::StringLiteral getMnemonic() {
    return {"ustruct"};
  }

  static ::mlir::Type parse(::mlir::AsmParser &odsParser);
  void print(::mlir::AsmPrinter &odsPrinter) const;
  ::llvm::ArrayRef<StructLikeMember> getMembers() const;
  ::std::optional<::llvm::DenseMap<::mlir::Attribute, ::mlir::Type>> getSubelementIndexMap() const;
  ::mlir::Type getTypeAtIndex(::mlir::Attribute index) const;
};
namespace detail {
struct UnionTypeStorage;
} // namespace detail
class UnionType : public ::mlir::Type::TypeBase<UnionType, moore::PackedType, detail::UnionTypeStorage, ::mlir::DestructurableTypeInterface::Trait> {
public:
  using Base::Base;
  std::optional<DenseMap<Attribute, Type>> getSubelementIndexMap();
  Type getTypeAtIndex(Attribute index);
  std::optional<uint32_t> getFieldIndex(StringAttr nameField);
  static constexpr ::llvm::StringLiteral name = "moore.union";
  static constexpr ::llvm::StringLiteral dialectName = "moore";
  using Base::getChecked;
  static UnionType get(::mlir::MLIRContext *context, ::llvm::ArrayRef<StructLikeMember> members);
  static UnionType getChecked(::llvm::function_ref<::mlir::InFlightDiagnostic()> emitError, ::mlir::MLIRContext *context, ::llvm::ArrayRef<StructLikeMember> members);
  static ::llvm::LogicalResult verify(::llvm::function_ref<::mlir::InFlightDiagnostic()> emitError, ::llvm::ArrayRef<StructLikeMember> members);
  static constexpr ::llvm::StringLiteral getMnemonic() {
    return {"union"};
  }

  static ::mlir::Type parse(::mlir::AsmParser &odsParser);
  void print(::mlir::AsmPrinter &odsPrinter) const;
  ::llvm::ArrayRef<StructLikeMember> getMembers() const;
  ::std::optional<::llvm::DenseMap<::mlir::Attribute, ::mlir::Type>> getSubelementIndexMap() const;
  ::mlir::Type getTypeAtIndex(::mlir::Attribute index) const;
};
namespace detail {
struct UnpackedUnionTypeStorage;
} // namespace detail
class UnpackedUnionType : public ::mlir::Type::TypeBase<UnpackedUnionType, moore::UnpackedType, detail::UnpackedUnionTypeStorage, ::mlir::DestructurableTypeInterface::Trait> {
public:
  using Base::Base;
  std::optional<DenseMap<Attribute, Type>> getSubelementIndexMap();
  Type getTypeAtIndex(Attribute index);
  std::optional<uint32_t> getFieldIndex(StringAttr nameField);
  static constexpr ::llvm::StringLiteral name = "moore.uunion";
  static constexpr ::llvm::StringLiteral dialectName = "moore";
  static UnpackedUnionType get(::mlir::MLIRContext *context, ::llvm::ArrayRef<StructLikeMember> members);
  static constexpr ::llvm::StringLiteral getMnemonic() {
    return {"uunion"};
  }

  static ::mlir::Type parse(::mlir::AsmParser &odsParser);
  void print(::mlir::AsmPrinter &odsPrinter) const;
  ::llvm::ArrayRef<StructLikeMember> getMembers() const;
  ::std::optional<::llvm::DenseMap<::mlir::Attribute, ::mlir::Type>> getSubelementIndexMap() const;
  ::mlir::Type getTypeAtIndex(::mlir::Attribute index) const;
};
namespace detail {
struct RefTypeStorage;
} // namespace detail
class RefType : public ::mlir::Type::TypeBase<RefType, moore::UnpackedType, detail::RefTypeStorage, ::mlir::DestructurableTypeInterface::Trait> {
public:
  using Base::Base;
  Domain getDomain() { return getNestedType().getDomain(); }
  std::optional<unsigned> getBitSize() {
    return getNestedType().getBitSize();
  };
  std::optional<DenseMap<Attribute, Type>> getSubelementIndexMap();
  Type getTypeAtIndex(Attribute index);
  std::optional<uint32_t> getFieldIndex(StringAttr nameField);
  static constexpr ::llvm::StringLiteral name = "moore.ref";
  static constexpr ::llvm::StringLiteral dialectName = "moore";
  static RefType get(::mlir::MLIRContext *context, UnpackedType nestedType);
  static RefType get(UnpackedType nestedType);
  static constexpr ::llvm::StringLiteral getMnemonic() {
    return {"ref"};
  }

  static ::mlir::Type parse(::mlir::AsmParser &odsParser);
  void print(::mlir::AsmPrinter &odsPrinter) const;
  UnpackedType getNestedType() const;
  ::std::optional<::llvm::DenseMap<::mlir::Attribute, ::mlir::Type>> getSubelementIndexMap() const;
  ::mlir::Type getTypeAtIndex(::mlir::Attribute index) const;
};
} // namespace moore
} // namespace circt
MLIR_DECLARE_EXPLICIT_TYPE_ID(::circt::moore::VoidType)
MLIR_DECLARE_EXPLICIT_TYPE_ID(::circt::moore::StringType)
MLIR_DECLARE_EXPLICIT_TYPE_ID(::circt::moore::ChandleType)
MLIR_DECLARE_EXPLICIT_TYPE_ID(::circt::moore::EventType)
MLIR_DECLARE_EXPLICIT_TYPE_ID(::circt::moore::IntType)
MLIR_DECLARE_EXPLICIT_TYPE_ID(::circt::moore::RealType)
MLIR_DECLARE_EXPLICIT_TYPE_ID(::circt::moore::ArrayType)
MLIR_DECLARE_EXPLICIT_TYPE_ID(::circt::moore::UnpackedArrayType)
MLIR_DECLARE_EXPLICIT_TYPE_ID(::circt::moore::OpenArrayType)
MLIR_DECLARE_EXPLICIT_TYPE_ID(::circt::moore::OpenUnpackedArrayType)
MLIR_DECLARE_EXPLICIT_TYPE_ID(::circt::moore::AssocArrayType)
MLIR_DECLARE_EXPLICIT_TYPE_ID(::circt::moore::QueueType)
MLIR_DECLARE_EXPLICIT_TYPE_ID(::circt::moore::StructType)
MLIR_DECLARE_EXPLICIT_TYPE_ID(::circt::moore::UnpackedStructType)
MLIR_DECLARE_EXPLICIT_TYPE_ID(::circt::moore::UnionType)
MLIR_DECLARE_EXPLICIT_TYPE_ID(::circt::moore::UnpackedUnionType)
MLIR_DECLARE_EXPLICIT_TYPE_ID(::circt::moore::RefType)

#endif  // GET_TYPEDEF_CLASSES

