/*===- TableGen'erated file -------------------------------------*- C++ -*-===*\
|*                                                                            *|
|* Interface Declarations                                                     *|
|*                                                                            *|
|* Automatically generated file, do not edit!                                 *|
|*                                                                            *|
\*===----------------------------------------------------------------------===*/

namespace circt {
namespace om {
class ClassLike;
namespace detail {
struct ClassLikeInterfaceTraits {
  struct Concept {
    /// The methods defined by the interface.
    llvm::StringRef (*getSymName)(const Concept *impl, ::mlir::Operation *);
    mlir::StringAttr (*getSymNameAttr)(const Concept *impl, ::mlir::Operation *);
    mlir::StringAttr (*getSymNameAttrName)(const Concept *impl, ::mlir::Operation *);
    mlir::ArrayAttr (*getFormalParamNames)(const Concept *impl, ::mlir::Operation *);
    mlir::StringAttr (*getFormalParamNamesAttrName)(const Concept *impl, ::mlir::Operation *);
    mlir::Region &(*getBody)(const Concept *impl, ::mlir::Operation *);
    mlir::Block *(*getBodyBlock)(const Concept *impl, ::mlir::Operation *);
  };
  template<typename ConcreteOp>
  class Model : public Concept {
  public:
    using Interface = circt::om::ClassLike;
    Model() : Concept{getSymName, getSymNameAttr, getSymNameAttrName, getFormalParamNames, getFormalParamNamesAttrName, getBody, getBodyBlock} {}

    static inline llvm::StringRef getSymName(const Concept *impl, ::mlir::Operation *tablegen_opaque_val);
    static inline mlir::StringAttr getSymNameAttr(const Concept *impl, ::mlir::Operation *tablegen_opaque_val);
    static inline mlir::StringAttr getSymNameAttrName(const Concept *impl, ::mlir::Operation *tablegen_opaque_val);
    static inline mlir::ArrayAttr getFormalParamNames(const Concept *impl, ::mlir::Operation *tablegen_opaque_val);
    static inline mlir::StringAttr getFormalParamNamesAttrName(const Concept *impl, ::mlir::Operation *tablegen_opaque_val);
    static inline mlir::Region &getBody(const Concept *impl, ::mlir::Operation *tablegen_opaque_val);
    static inline mlir::Block *getBodyBlock(const Concept *impl, ::mlir::Operation *tablegen_opaque_val);
  };
  template<typename ConcreteOp>
  class FallbackModel : public Concept {
  public:
    using Interface = circt::om::ClassLike;
    FallbackModel() : Concept{getSymName, getSymNameAttr, getSymNameAttrName, getFormalParamNames, getFormalParamNamesAttrName, getBody, getBodyBlock} {}

    static inline llvm::StringRef getSymName(const Concept *impl, ::mlir::Operation *tablegen_opaque_val);
    static inline mlir::StringAttr getSymNameAttr(const Concept *impl, ::mlir::Operation *tablegen_opaque_val);
    static inline mlir::StringAttr getSymNameAttrName(const Concept *impl, ::mlir::Operation *tablegen_opaque_val);
    static inline mlir::ArrayAttr getFormalParamNames(const Concept *impl, ::mlir::Operation *tablegen_opaque_val);
    static inline mlir::StringAttr getFormalParamNamesAttrName(const Concept *impl, ::mlir::Operation *tablegen_opaque_val);
    static inline mlir::Region &getBody(const Concept *impl, ::mlir::Operation *tablegen_opaque_val);
    static inline mlir::Block *getBodyBlock(const Concept *impl, ::mlir::Operation *tablegen_opaque_val);
  };
  template<typename ConcreteModel, typename ConcreteOp>
  class ExternalModel : public FallbackModel<ConcreteModel> {
  public:
    using ConcreteEntity = ConcreteOp;
  };
};
template <typename ConcreteOp>
struct ClassLikeTrait;

} // namespace detail
class ClassLike : public ::mlir::OpInterface<ClassLike, detail::ClassLikeInterfaceTraits> {
public:
  using ::mlir::OpInterface<ClassLike, detail::ClassLikeInterfaceTraits>::OpInterface;
  template <typename ConcreteOp>
  struct Trait : public detail::ClassLikeTrait<ConcreteOp> {};
  /// Get the class-like symbol name
  llvm::StringRef getSymName();
  /// Get the class-like symbol name attribute
  mlir::StringAttr getSymNameAttr();
  /// Get the class-like symbol name attribute name
  mlir::StringAttr getSymNameAttrName();
  /// Get the class-like formal parameter names attribute
  mlir::ArrayAttr getFormalParamNames();
  /// Get the class-like formal parameter names attribute name
  mlir::StringAttr getFormalParamNamesAttrName();
  /// Get the class-like body region
  mlir::Region &getBody();
  /// Get the class-like body block
  mlir::Block *getBodyBlock();
};
namespace detail {
  template <typename ConcreteOp>
  struct ClassLikeTrait : public ::mlir::OpInterface<ClassLike, detail::ClassLikeInterfaceTraits>::Trait<ConcreteOp> {
  };
}// namespace detail
} // namespace om
} // namespace circt
namespace circt {
namespace om {
class ClassFieldLike;
namespace detail {
struct ClassFieldLikeInterfaceTraits {
  struct Concept {
    /// The methods defined by the interface.
    mlir::Type (*getType)(const Concept *impl, ::mlir::Operation *);
    mlir::StringAttr (*getNameAttr)(const Concept *impl, ::mlir::Operation *);
  };
  template<typename ConcreteOp>
  class Model : public Concept {
  public:
    using Interface = circt::om::ClassFieldLike;
    Model() : Concept{getType, getNameAttr} {}

    static inline mlir::Type getType(const Concept *impl, ::mlir::Operation *tablegen_opaque_val);
    static inline mlir::StringAttr getNameAttr(const Concept *impl, ::mlir::Operation *tablegen_opaque_val);
  };
  template<typename ConcreteOp>
  class FallbackModel : public Concept {
  public:
    using Interface = circt::om::ClassFieldLike;
    FallbackModel() : Concept{getType, getNameAttr} {}

    static inline mlir::Type getType(const Concept *impl, ::mlir::Operation *tablegen_opaque_val);
    static inline mlir::StringAttr getNameAttr(const Concept *impl, ::mlir::Operation *tablegen_opaque_val);
  };
  template<typename ConcreteModel, typename ConcreteOp>
  class ExternalModel : public FallbackModel<ConcreteModel> {
  public:
    using ConcreteEntity = ConcreteOp;
  };
};
template <typename ConcreteOp>
struct ClassFieldLikeTrait;

} // namespace detail
class ClassFieldLike : public ::mlir::OpInterface<ClassFieldLike, detail::ClassFieldLikeInterfaceTraits> {
public:
  using ::mlir::OpInterface<ClassFieldLike, detail::ClassFieldLikeInterfaceTraits>::OpInterface;
  template <typename ConcreteOp>
  struct Trait : public detail::ClassFieldLikeTrait<ConcreteOp> {};
  /// Get the class-like field's type
  mlir::Type getType();
  /// Get the class-like field's name attribute
  mlir::StringAttr getNameAttr();
};
namespace detail {
  template <typename ConcreteOp>
  struct ClassFieldLikeTrait : public ::mlir::OpInterface<ClassFieldLike, detail::ClassFieldLikeInterfaceTraits>::Trait<ConcreteOp> {
  };
}// namespace detail
} // namespace om
} // namespace circt
namespace circt {
namespace om {
class IntegerBinaryArithmeticOp;
namespace detail {
struct IntegerBinaryArithmeticOpInterfaceTraits {
  struct Concept {
    /// The methods defined by the interface.
    mlir::Value (*getLhs)(const Concept *impl, ::mlir::Operation *);
    mlir::Value (*getRhs)(const Concept *impl, ::mlir::Operation *);
    mlir::Value (*getResult)(const Concept *impl, ::mlir::Operation *);
    mlir::FailureOr<llvm::APSInt> (*evaluateIntegerOperation)(const Concept *impl, ::mlir::Operation *, const llvm::APSInt &, const llvm::APSInt &);
  };
  template<typename ConcreteOp>
  class Model : public Concept {
  public:
    using Interface = circt::om::IntegerBinaryArithmeticOp;
    Model() : Concept{getLhs, getRhs, getResult, evaluateIntegerOperation} {}

    static inline mlir::Value getLhs(const Concept *impl, ::mlir::Operation *tablegen_opaque_val);
    static inline mlir::Value getRhs(const Concept *impl, ::mlir::Operation *tablegen_opaque_val);
    static inline mlir::Value getResult(const Concept *impl, ::mlir::Operation *tablegen_opaque_val);
    static inline mlir::FailureOr<llvm::APSInt> evaluateIntegerOperation(const Concept *impl, ::mlir::Operation *tablegen_opaque_val, const llvm::APSInt & lhs, const llvm::APSInt & rhs);
  };
  template<typename ConcreteOp>
  class FallbackModel : public Concept {
  public:
    using Interface = circt::om::IntegerBinaryArithmeticOp;
    FallbackModel() : Concept{getLhs, getRhs, getResult, evaluateIntegerOperation} {}

    static inline mlir::Value getLhs(const Concept *impl, ::mlir::Operation *tablegen_opaque_val);
    static inline mlir::Value getRhs(const Concept *impl, ::mlir::Operation *tablegen_opaque_val);
    static inline mlir::Value getResult(const Concept *impl, ::mlir::Operation *tablegen_opaque_val);
    static inline mlir::FailureOr<llvm::APSInt> evaluateIntegerOperation(const Concept *impl, ::mlir::Operation *tablegen_opaque_val, const llvm::APSInt & lhs, const llvm::APSInt & rhs);
  };
  template<typename ConcreteModel, typename ConcreteOp>
  class ExternalModel : public FallbackModel<ConcreteModel> {
  public:
    using ConcreteEntity = ConcreteOp;
  };
};
template <typename ConcreteOp>
struct IntegerBinaryArithmeticOpTrait;

} // namespace detail
class IntegerBinaryArithmeticOp : public ::mlir::OpInterface<IntegerBinaryArithmeticOp, detail::IntegerBinaryArithmeticOpInterfaceTraits> {
public:
  using ::mlir::OpInterface<IntegerBinaryArithmeticOp, detail::IntegerBinaryArithmeticOpInterfaceTraits>::OpInterface;
  template <typename ConcreteOp>
  struct Trait : public detail::IntegerBinaryArithmeticOpTrait<ConcreteOp> {};
  /// Get the lhs Value
  mlir::Value getLhs();
  /// Get the rhs Value
  mlir::Value getRhs();
  /// Get the result Value
  mlir::Value getResult();
  /// Evaluate the integer binary arithmetic operation
  mlir::FailureOr<llvm::APSInt> evaluateIntegerOperation(const llvm::APSInt & lhs, const llvm::APSInt & rhs);
};
namespace detail {
  template <typename ConcreteOp>
  struct IntegerBinaryArithmeticOpTrait : public ::mlir::OpInterface<IntegerBinaryArithmeticOp, detail::IntegerBinaryArithmeticOpInterfaceTraits>::Trait<ConcreteOp> {
  };
}// namespace detail
} // namespace om
} // namespace circt
namespace circt {
namespace om {
template<typename ConcreteOp>
llvm::StringRef detail::ClassLikeInterfaceTraits::Model<ConcreteOp>::getSymName(const Concept *impl, ::mlir::Operation *tablegen_opaque_val) {
  return (llvm::cast<ConcreteOp>(tablegen_opaque_val)).getSymName();
}
template<typename ConcreteOp>
mlir::StringAttr detail::ClassLikeInterfaceTraits::Model<ConcreteOp>::getSymNameAttr(const Concept *impl, ::mlir::Operation *tablegen_opaque_val) {
  return (llvm::cast<ConcreteOp>(tablegen_opaque_val)).getSymNameAttr();
}
template<typename ConcreteOp>
mlir::StringAttr detail::ClassLikeInterfaceTraits::Model<ConcreteOp>::getSymNameAttrName(const Concept *impl, ::mlir::Operation *tablegen_opaque_val) {
  return (llvm::cast<ConcreteOp>(tablegen_opaque_val)).getSymNameAttrName();
}
template<typename ConcreteOp>
mlir::ArrayAttr detail::ClassLikeInterfaceTraits::Model<ConcreteOp>::getFormalParamNames(const Concept *impl, ::mlir::Operation *tablegen_opaque_val) {
  return (llvm::cast<ConcreteOp>(tablegen_opaque_val)).getFormalParamNames();
}
template<typename ConcreteOp>
mlir::StringAttr detail::ClassLikeInterfaceTraits::Model<ConcreteOp>::getFormalParamNamesAttrName(const Concept *impl, ::mlir::Operation *tablegen_opaque_val) {
  return (llvm::cast<ConcreteOp>(tablegen_opaque_val)).getFormalParamNamesAttrName();
}
template<typename ConcreteOp>
mlir::Region &detail::ClassLikeInterfaceTraits::Model<ConcreteOp>::getBody(const Concept *impl, ::mlir::Operation *tablegen_opaque_val) {
  return (llvm::cast<ConcreteOp>(tablegen_opaque_val)).getBody();
}
template<typename ConcreteOp>
mlir::Block *detail::ClassLikeInterfaceTraits::Model<ConcreteOp>::getBodyBlock(const Concept *impl, ::mlir::Operation *tablegen_opaque_val) {
  return (llvm::cast<ConcreteOp>(tablegen_opaque_val)).getBodyBlock();
}
template<typename ConcreteOp>
llvm::StringRef detail::ClassLikeInterfaceTraits::FallbackModel<ConcreteOp>::getSymName(const Concept *impl, ::mlir::Operation *tablegen_opaque_val) {
  return static_cast<const ConcreteOp *>(impl)->getSymName(tablegen_opaque_val);
}
template<typename ConcreteOp>
mlir::StringAttr detail::ClassLikeInterfaceTraits::FallbackModel<ConcreteOp>::getSymNameAttr(const Concept *impl, ::mlir::Operation *tablegen_opaque_val) {
  return static_cast<const ConcreteOp *>(impl)->getSymNameAttr(tablegen_opaque_val);
}
template<typename ConcreteOp>
mlir::StringAttr detail::ClassLikeInterfaceTraits::FallbackModel<ConcreteOp>::getSymNameAttrName(const Concept *impl, ::mlir::Operation *tablegen_opaque_val) {
  return static_cast<const ConcreteOp *>(impl)->getSymNameAttrName(tablegen_opaque_val);
}
template<typename ConcreteOp>
mlir::ArrayAttr detail::ClassLikeInterfaceTraits::FallbackModel<ConcreteOp>::getFormalParamNames(const Concept *impl, ::mlir::Operation *tablegen_opaque_val) {
  return static_cast<const ConcreteOp *>(impl)->getFormalParamNames(tablegen_opaque_val);
}
template<typename ConcreteOp>
mlir::StringAttr detail::ClassLikeInterfaceTraits::FallbackModel<ConcreteOp>::getFormalParamNamesAttrName(const Concept *impl, ::mlir::Operation *tablegen_opaque_val) {
  return static_cast<const ConcreteOp *>(impl)->getFormalParamNamesAttrName(tablegen_opaque_val);
}
template<typename ConcreteOp>
mlir::Region &detail::ClassLikeInterfaceTraits::FallbackModel<ConcreteOp>::getBody(const Concept *impl, ::mlir::Operation *tablegen_opaque_val) {
  return static_cast<const ConcreteOp *>(impl)->getBody(tablegen_opaque_val);
}
template<typename ConcreteOp>
mlir::Block *detail::ClassLikeInterfaceTraits::FallbackModel<ConcreteOp>::getBodyBlock(const Concept *impl, ::mlir::Operation *tablegen_opaque_val) {
  return static_cast<const ConcreteOp *>(impl)->getBodyBlock(tablegen_opaque_val);
}
} // namespace om
} // namespace circt
namespace circt {
namespace om {
template<typename ConcreteOp>
mlir::Type detail::ClassFieldLikeInterfaceTraits::Model<ConcreteOp>::getType(const Concept *impl, ::mlir::Operation *tablegen_opaque_val) {
  return (llvm::cast<ConcreteOp>(tablegen_opaque_val)).getType();
}
template<typename ConcreteOp>
mlir::StringAttr detail::ClassFieldLikeInterfaceTraits::Model<ConcreteOp>::getNameAttr(const Concept *impl, ::mlir::Operation *tablegen_opaque_val) {
  return (llvm::cast<ConcreteOp>(tablegen_opaque_val)).getNameAttr();
}
template<typename ConcreteOp>
mlir::Type detail::ClassFieldLikeInterfaceTraits::FallbackModel<ConcreteOp>::getType(const Concept *impl, ::mlir::Operation *tablegen_opaque_val) {
  return static_cast<const ConcreteOp *>(impl)->getType(tablegen_opaque_val);
}
template<typename ConcreteOp>
mlir::StringAttr detail::ClassFieldLikeInterfaceTraits::FallbackModel<ConcreteOp>::getNameAttr(const Concept *impl, ::mlir::Operation *tablegen_opaque_val) {
  return static_cast<const ConcreteOp *>(impl)->getNameAttr(tablegen_opaque_val);
}
} // namespace om
} // namespace circt
namespace circt {
namespace om {
template<typename ConcreteOp>
mlir::Value detail::IntegerBinaryArithmeticOpInterfaceTraits::Model<ConcreteOp>::getLhs(const Concept *impl, ::mlir::Operation *tablegen_opaque_val) {
  return (llvm::cast<ConcreteOp>(tablegen_opaque_val)).getLhs();
}
template<typename ConcreteOp>
mlir::Value detail::IntegerBinaryArithmeticOpInterfaceTraits::Model<ConcreteOp>::getRhs(const Concept *impl, ::mlir::Operation *tablegen_opaque_val) {
  return (llvm::cast<ConcreteOp>(tablegen_opaque_val)).getRhs();
}
template<typename ConcreteOp>
mlir::Value detail::IntegerBinaryArithmeticOpInterfaceTraits::Model<ConcreteOp>::getResult(const Concept *impl, ::mlir::Operation *tablegen_opaque_val) {
  return (llvm::cast<ConcreteOp>(tablegen_opaque_val)).getResult();
}
template<typename ConcreteOp>
mlir::FailureOr<llvm::APSInt> detail::IntegerBinaryArithmeticOpInterfaceTraits::Model<ConcreteOp>::evaluateIntegerOperation(const Concept *impl, ::mlir::Operation *tablegen_opaque_val, const llvm::APSInt & lhs, const llvm::APSInt & rhs) {
  return (llvm::cast<ConcreteOp>(tablegen_opaque_val)).evaluateIntegerOperation(lhs, rhs);
}
template<typename ConcreteOp>
mlir::Value detail::IntegerBinaryArithmeticOpInterfaceTraits::FallbackModel<ConcreteOp>::getLhs(const Concept *impl, ::mlir::Operation *tablegen_opaque_val) {
  return static_cast<const ConcreteOp *>(impl)->getLhs(tablegen_opaque_val);
}
template<typename ConcreteOp>
mlir::Value detail::IntegerBinaryArithmeticOpInterfaceTraits::FallbackModel<ConcreteOp>::getRhs(const Concept *impl, ::mlir::Operation *tablegen_opaque_val) {
  return static_cast<const ConcreteOp *>(impl)->getRhs(tablegen_opaque_val);
}
template<typename ConcreteOp>
mlir::Value detail::IntegerBinaryArithmeticOpInterfaceTraits::FallbackModel<ConcreteOp>::getResult(const Concept *impl, ::mlir::Operation *tablegen_opaque_val) {
  return static_cast<const ConcreteOp *>(impl)->getResult(tablegen_opaque_val);
}
template<typename ConcreteOp>
mlir::FailureOr<llvm::APSInt> detail::IntegerBinaryArithmeticOpInterfaceTraits::FallbackModel<ConcreteOp>::evaluateIntegerOperation(const Concept *impl, ::mlir::Operation *tablegen_opaque_val, const llvm::APSInt & lhs, const llvm::APSInt & rhs) {
  return static_cast<const ConcreteOp *>(impl)->evaluateIntegerOperation(tablegen_opaque_val, lhs, rhs);
}
} // namespace om
} // namespace circt
