/*===- TableGen'erated file -------------------------------------*- C++ -*-===*\
|*                                                                            *|
|* Enum Utility Declarations                                                  *|
|*                                                                            *|
|* Automatically generated file, do not edit!                                 *|
|* From: SMT.td                                                               *|
|*                                                                            *|
\*===----------------------------------------------------------------------===*/

namespace circt {
namespace smt {
// smt bit-vector comparison predicate
enum class BVCmpPredicate : uint64_t {
  slt = 0,
  sle = 1,
  sgt = 2,
  sge = 3,
  ult = 4,
  ule = 5,
  ugt = 6,
  uge = 7,
};

::std::optional<BVCmpPredicate> symbolizeBVCmpPredicate(uint64_t);
::llvm::StringRef stringifyBVCmpPredicate(BVCmpPredicate);
::std::optional<BVCmpPredicate> symbolizeBVCmpPredicate(::llvm::StringRef);
inline constexpr unsigned getMaxEnumValForBVCmpPredicate() {
  return 7;
}


inline ::llvm::StringRef stringifyEnum(BVCmpPredicate enumValue) {
  return stringifyBVCmpPredicate(enumValue);
}

template <typename EnumType>
::std::optional<EnumType> symbolizeEnum(::llvm::StringRef);

template <>
inline ::std::optional<BVCmpPredicate> symbolizeEnum<BVCmpPredicate>(::llvm::StringRef str) {
  return symbolizeBVCmpPredicate(str);
}

class BVCmpPredicateAttr : public ::mlir::IntegerAttr {
public:
  using ValueType = BVCmpPredicate;
  using ::mlir::IntegerAttr::IntegerAttr;
  static bool classof(::mlir::Attribute attr);
  static BVCmpPredicateAttr get(::mlir::MLIRContext *context, BVCmpPredicate val);
  BVCmpPredicate getValue() const;
};
} // namespace smt
} // namespace circt

namespace mlir {
template <typename T, typename>
struct FieldParser;

template<>
struct FieldParser<circt::smt::BVCmpPredicate, circt::smt::BVCmpPredicate> {
  template <typename ParserT>
  static FailureOr<circt::smt::BVCmpPredicate> parse(ParserT &parser) {
    // Parse the keyword/string containing the enum.
    std::string enumKeyword;
    auto loc = parser.getCurrentLocation();
    if (failed(parser.parseOptionalKeywordOrString(&enumKeyword)))
      return parser.emitError(loc, "expected keyword for smt bit-vector comparison predicate");

    // Symbolize the keyword.
    if (::std::optional<circt::smt::BVCmpPredicate> attr = circt::smt::symbolizeEnum<circt::smt::BVCmpPredicate>(enumKeyword))
      return *attr;
    return parser.emitError(loc, "invalid smt bit-vector comparison predicate specification: ") << enumKeyword;
  }
};
} // namespace mlir

namespace llvm {
inline ::llvm::raw_ostream &operator<<(::llvm::raw_ostream &p, circt::smt::BVCmpPredicate value) {
  auto valueStr = stringifyEnum(value);
  return p << valueStr;
}
} // namespace llvm

namespace llvm {
template<> struct DenseMapInfo<circt::smt::BVCmpPredicate> {
  using StorageInfo = ::llvm::DenseMapInfo<uint64_t>;

  static inline circt::smt::BVCmpPredicate getEmptyKey() {
    return static_cast<circt::smt::BVCmpPredicate>(StorageInfo::getEmptyKey());
  }

  static inline circt::smt::BVCmpPredicate getTombstoneKey() {
    return static_cast<circt::smt::BVCmpPredicate>(StorageInfo::getTombstoneKey());
  }

  static unsigned getHashValue(const circt::smt::BVCmpPredicate &val) {
    return StorageInfo::getHashValue(static_cast<uint64_t>(val));
  }

  static bool isEqual(const circt::smt::BVCmpPredicate &lhs, const circt::smt::BVCmpPredicate &rhs) {
    return lhs == rhs;
  }
};
}

namespace circt {
namespace smt {
// smt comparison predicate for integers
enum class IntPredicate : uint64_t {
  lt = 0,
  le = 1,
  gt = 2,
  ge = 3,
};

::std::optional<IntPredicate> symbolizeIntPredicate(uint64_t);
::llvm::StringRef stringifyIntPredicate(IntPredicate);
::std::optional<IntPredicate> symbolizeIntPredicate(::llvm::StringRef);
inline constexpr unsigned getMaxEnumValForIntPredicate() {
  return 3;
}


inline ::llvm::StringRef stringifyEnum(IntPredicate enumValue) {
  return stringifyIntPredicate(enumValue);
}

template <typename EnumType>
::std::optional<EnumType> symbolizeEnum(::llvm::StringRef);

template <>
inline ::std::optional<IntPredicate> symbolizeEnum<IntPredicate>(::llvm::StringRef str) {
  return symbolizeIntPredicate(str);
}

class IntPredicateAttr : public ::mlir::IntegerAttr {
public:
  using ValueType = IntPredicate;
  using ::mlir::IntegerAttr::IntegerAttr;
  static bool classof(::mlir::Attribute attr);
  static IntPredicateAttr get(::mlir::MLIRContext *context, IntPredicate val);
  IntPredicate getValue() const;
};
} // namespace smt
} // namespace circt

namespace mlir {
template <typename T, typename>
struct FieldParser;

template<>
struct FieldParser<circt::smt::IntPredicate, circt::smt::IntPredicate> {
  template <typename ParserT>
  static FailureOr<circt::smt::IntPredicate> parse(ParserT &parser) {
    // Parse the keyword/string containing the enum.
    std::string enumKeyword;
    auto loc = parser.getCurrentLocation();
    if (failed(parser.parseOptionalKeywordOrString(&enumKeyword)))
      return parser.emitError(loc, "expected keyword for smt comparison predicate for integers");

    // Symbolize the keyword.
    if (::std::optional<circt::smt::IntPredicate> attr = circt::smt::symbolizeEnum<circt::smt::IntPredicate>(enumKeyword))
      return *attr;
    return parser.emitError(loc, "invalid smt comparison predicate for integers specification: ") << enumKeyword;
  }
};
} // namespace mlir

namespace llvm {
inline ::llvm::raw_ostream &operator<<(::llvm::raw_ostream &p, circt::smt::IntPredicate value) {
  auto valueStr = stringifyEnum(value);
  return p << valueStr;
}
} // namespace llvm

namespace llvm {
template<> struct DenseMapInfo<circt::smt::IntPredicate> {
  using StorageInfo = ::llvm::DenseMapInfo<uint64_t>;

  static inline circt::smt::IntPredicate getEmptyKey() {
    return static_cast<circt::smt::IntPredicate>(StorageInfo::getEmptyKey());
  }

  static inline circt::smt::IntPredicate getTombstoneKey() {
    return static_cast<circt::smt::IntPredicate>(StorageInfo::getTombstoneKey());
  }

  static unsigned getHashValue(const circt::smt::IntPredicate &val) {
    return StorageInfo::getHashValue(static_cast<uint64_t>(val));
  }

  static bool isEqual(const circt::smt::IntPredicate &lhs, const circt::smt::IntPredicate &rhs) {
    return lhs == rhs;
  }
};
}

