/* Autogenerated by mlir-tblgen; don't manually edit */

#ifdef GEN_PASS_DECL
// Generate declarations for all passes.
#define GEN_PASS_DECL_LOWERDPIFUNC
#define GEN_PASS_DECL_PROCEDURALIZESIM
#undef GEN_PASS_DECL
#endif // GEN_PASS_DECL

//===----------------------------------------------------------------------===//
// LowerDPIFunc
//===----------------------------------------------------------------------===//
#ifdef GEN_PASS_DECL_LOWERDPIFUNC
std::unique_ptr<::mlir::Pass> createLowerDPIFunc();
#undef GEN_PASS_DECL_LOWERDPIFUNC
#endif // GEN_PASS_DECL_LOWERDPIFUNC
#ifdef GEN_PASS_DEF_LOWERDPIFUNC

namespace impl {
  std::unique_ptr<::mlir::Pass> createLowerDPIFunc();
} // namespace impl
namespace impl {

template <typename DerivedT>
class LowerDPIFuncBase : public ::mlir::OperationPass<mlir::ModuleOp> {
public:
  using Base = LowerDPIFuncBase;

  LowerDPIFuncBase() : ::mlir::OperationPass<mlir::ModuleOp>(::mlir::TypeID::get<DerivedT>()) {}
  LowerDPIFuncBase(const LowerDPIFuncBase &other) : ::mlir::OperationPass<mlir::ModuleOp>(other) {}
  LowerDPIFuncBase& operator=(const LowerDPIFuncBase &) = delete;
  LowerDPIFuncBase(LowerDPIFuncBase &&) = delete;
  LowerDPIFuncBase& operator=(LowerDPIFuncBase &&) = delete;
  ~LowerDPIFuncBase() = default;

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("sim-lower-dpi-func");
  }
  ::llvm::StringRef getArgument() const override { return "sim-lower-dpi-func"; }

  ::llvm::StringRef getDescription() const override { return "Lower sim.dpi.func into func.func for the simulation flow"; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("LowerDPIFunc");
  }
  ::llvm::StringRef getName() const override { return "LowerDPIFunc"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Return the dialect that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    registry.insert<mlir::func::FuncDialect>();
    registry.insert<mlir::LLVM::LLVMDialect>();
  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(LowerDPIFuncBase<DerivedT>)

protected:
private:

  friend std::unique_ptr<::mlir::Pass> createLowerDPIFunc() {
    return std::make_unique<DerivedT>();
  }
};
} // namespace impl

std::unique_ptr<::mlir::Pass> createLowerDPIFunc() {
  return impl::createLowerDPIFunc();
}
#undef GEN_PASS_DEF_LOWERDPIFUNC
#endif // GEN_PASS_DEF_LOWERDPIFUNC

//===----------------------------------------------------------------------===//
// ProceduralizeSim
//===----------------------------------------------------------------------===//
#ifdef GEN_PASS_DECL_PROCEDURALIZESIM
std::unique_ptr<::mlir::Pass> createProceduralizeSim();
#undef GEN_PASS_DECL_PROCEDURALIZESIM
#endif // GEN_PASS_DECL_PROCEDURALIZESIM
#ifdef GEN_PASS_DEF_PROCEDURALIZESIM

namespace impl {
  std::unique_ptr<::mlir::Pass> createProceduralizeSim();
} // namespace impl
namespace impl {

template <typename DerivedT>
class ProceduralizeSimBase : public ::mlir::OperationPass<hw::HWModuleOp> {
public:
  using Base = ProceduralizeSimBase;

  ProceduralizeSimBase() : ::mlir::OperationPass<hw::HWModuleOp>(::mlir::TypeID::get<DerivedT>()) {}
  ProceduralizeSimBase(const ProceduralizeSimBase &other) : ::mlir::OperationPass<hw::HWModuleOp>(other) {}
  ProceduralizeSimBase& operator=(const ProceduralizeSimBase &) = delete;
  ProceduralizeSimBase(ProceduralizeSimBase &&) = delete;
  ProceduralizeSimBase& operator=(ProceduralizeSimBase &&) = delete;
  ~ProceduralizeSimBase() = default;

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("sim-proceduralize");
  }
  ::llvm::StringRef getArgument() const override { return "sim-proceduralize"; }

  ::llvm::StringRef getDescription() const override { return "Transform non-procedural to procedural operations."; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("ProceduralizeSim");
  }
  ::llvm::StringRef getName() const override { return "ProceduralizeSim"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Return the dialect that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    registry.insert<circt::hw::HWDialect, circt::seq::SeqDialect, mlir::scf::SCFDialect>();
  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(ProceduralizeSimBase<DerivedT>)

protected:
private:

  friend std::unique_ptr<::mlir::Pass> createProceduralizeSim() {
    return std::make_unique<DerivedT>();
  }
};
} // namespace impl

std::unique_ptr<::mlir::Pass> createProceduralizeSim() {
  return impl::createProceduralizeSim();
}
#undef GEN_PASS_DEF_PROCEDURALIZESIM
#endif // GEN_PASS_DEF_PROCEDURALIZESIM
#ifdef GEN_PASS_REGISTRATION

//===----------------------------------------------------------------------===//
// LowerDPIFunc Registration
//===----------------------------------------------------------------------===//

inline void registerLowerDPIFunc() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return createLowerDPIFunc();
  });
}

// Old registration code, kept for temporary backwards compatibility.
inline void registerLowerDPIFuncPass() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return createLowerDPIFunc();
  });
}

//===----------------------------------------------------------------------===//
// ProceduralizeSim Registration
//===----------------------------------------------------------------------===//

inline void registerProceduralizeSim() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return createProceduralizeSim();
  });
}

// Old registration code, kept for temporary backwards compatibility.
inline void registerProceduralizeSimPass() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return createProceduralizeSim();
  });
}

//===----------------------------------------------------------------------===//
//  Registration
//===----------------------------------------------------------------------===//

inline void registerPasses() {
  registerLowerDPIFunc();
  registerProceduralizeSim();
}
#undef GEN_PASS_REGISTRATION
#endif // GEN_PASS_REGISTRATION
// Deprecated. Please use the new per-pass macros.
#ifdef GEN_PASS_CLASSES

template <typename DerivedT>
class LowerDPIFuncBase : public ::mlir::OperationPass<mlir::ModuleOp> {
public:
  using Base = LowerDPIFuncBase;

  LowerDPIFuncBase() : ::mlir::OperationPass<mlir::ModuleOp>(::mlir::TypeID::get<DerivedT>()) {}
  LowerDPIFuncBase(const LowerDPIFuncBase &other) : ::mlir::OperationPass<mlir::ModuleOp>(other) {}
  LowerDPIFuncBase& operator=(const LowerDPIFuncBase &) = delete;
  LowerDPIFuncBase(LowerDPIFuncBase &&) = delete;
  LowerDPIFuncBase& operator=(LowerDPIFuncBase &&) = delete;
  ~LowerDPIFuncBase() = default;

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("sim-lower-dpi-func");
  }
  ::llvm::StringRef getArgument() const override { return "sim-lower-dpi-func"; }

  ::llvm::StringRef getDescription() const override { return "Lower sim.dpi.func into func.func for the simulation flow"; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("LowerDPIFunc");
  }
  ::llvm::StringRef getName() const override { return "LowerDPIFunc"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Register the dialects that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    registry.insert<mlir::func::FuncDialect>();
    registry.insert<mlir::LLVM::LLVMDialect>();
  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(LowerDPIFuncBase<DerivedT>)

protected:
};

template <typename DerivedT>
class ProceduralizeSimBase : public ::mlir::OperationPass<hw::HWModuleOp> {
public:
  using Base = ProceduralizeSimBase;

  ProceduralizeSimBase() : ::mlir::OperationPass<hw::HWModuleOp>(::mlir::TypeID::get<DerivedT>()) {}
  ProceduralizeSimBase(const ProceduralizeSimBase &other) : ::mlir::OperationPass<hw::HWModuleOp>(other) {}
  ProceduralizeSimBase& operator=(const ProceduralizeSimBase &) = delete;
  ProceduralizeSimBase(ProceduralizeSimBase &&) = delete;
  ProceduralizeSimBase& operator=(ProceduralizeSimBase &&) = delete;
  ~ProceduralizeSimBase() = default;

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("sim-proceduralize");
  }
  ::llvm::StringRef getArgument() const override { return "sim-proceduralize"; }

  ::llvm::StringRef getDescription() const override { return "Transform non-procedural to procedural operations."; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("ProceduralizeSim");
  }
  ::llvm::StringRef getName() const override { return "ProceduralizeSim"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Register the dialects that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    registry.insert<circt::hw::HWDialect, circt::seq::SeqDialect, mlir::scf::SCFDialect>();
  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(ProceduralizeSimBase<DerivedT>)

protected:
};
#undef GEN_PASS_CLASSES
#endif // GEN_PASS_CLASSES
