/* Autogenerated by mlir-tblgen; don't manually edit */

#ifdef GEN_PASS_DECL
// Generate declarations for all passes.
#define GEN_PASS_DECL_EXTERNALIZEREGISTERS
#define GEN_PASS_DECL_LOWERTOBMC
#undef GEN_PASS_DECL
#endif // GEN_PASS_DECL

//===----------------------------------------------------------------------===//
// ExternalizeRegisters
//===----------------------------------------------------------------------===//
#ifdef GEN_PASS_DECL_EXTERNALIZEREGISTERS
std::unique_ptr<::mlir::Pass> createExternalizeRegisters();
#undef GEN_PASS_DECL_EXTERNALIZEREGISTERS
#endif // GEN_PASS_DECL_EXTERNALIZEREGISTERS
#ifdef GEN_PASS_DEF_EXTERNALIZEREGISTERS

namespace impl {
  std::unique_ptr<::mlir::Pass> createExternalizeRegisters();
} // namespace impl
namespace impl {

template <typename DerivedT>
class ExternalizeRegistersBase : public ::mlir::OperationPass<::mlir::ModuleOp> {
public:
  using Base = ExternalizeRegistersBase;

  ExternalizeRegistersBase() : ::mlir::OperationPass<::mlir::ModuleOp>(::mlir::TypeID::get<DerivedT>()) {}
  ExternalizeRegistersBase(const ExternalizeRegistersBase &other) : ::mlir::OperationPass<::mlir::ModuleOp>(other) {}
  ExternalizeRegistersBase& operator=(const ExternalizeRegistersBase &) = delete;
  ExternalizeRegistersBase(ExternalizeRegistersBase &&) = delete;
  ExternalizeRegistersBase& operator=(ExternalizeRegistersBase &&) = delete;
  ~ExternalizeRegistersBase() = default;

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("externalize-registers");
  }
  ::llvm::StringRef getArgument() const override { return "externalize-registers"; }

  ::llvm::StringRef getDescription() const override { return "Removes registers and adds corresponding input and output ports"; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("ExternalizeRegisters");
  }
  ::llvm::StringRef getName() const override { return "ExternalizeRegisters"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Return the dialect that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    registry.insert<circt::seq::SeqDialect>();
    registry.insert<circt::hw::HWDialect>();
  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(ExternalizeRegistersBase<DerivedT>)

protected:
private:

  friend std::unique_ptr<::mlir::Pass> createExternalizeRegisters() {
    return std::make_unique<DerivedT>();
  }
};
} // namespace impl

std::unique_ptr<::mlir::Pass> createExternalizeRegisters() {
  return impl::createExternalizeRegisters();
}
#undef GEN_PASS_DEF_EXTERNALIZEREGISTERS
#endif // GEN_PASS_DEF_EXTERNALIZEREGISTERS

//===----------------------------------------------------------------------===//
// LowerToBMC
//===----------------------------------------------------------------------===//
#ifdef GEN_PASS_DECL_LOWERTOBMC
struct LowerToBMCOptions {
  std::string topModule;
  unsigned bound;
  bool insertMainFunc = false;
};
std::unique_ptr<::mlir::Pass> createLowerToBMC();
std::unique_ptr<::mlir::Pass> createLowerToBMC(const LowerToBMCOptions &options);
#undef GEN_PASS_DECL_LOWERTOBMC
#endif // GEN_PASS_DECL_LOWERTOBMC
#ifdef GEN_PASS_DEF_LOWERTOBMC

namespace impl {
  std::unique_ptr<::mlir::Pass> createLowerToBMC();
} // namespace impl

namespace impl {
  std::unique_ptr<::mlir::Pass> createLowerToBMC(const LowerToBMCOptions &options);
} // namespace impl
namespace impl {

template <typename DerivedT>
class LowerToBMCBase : public ::mlir::OperationPass<::mlir::ModuleOp> {
public:
  using Base = LowerToBMCBase;

  LowerToBMCBase() : ::mlir::OperationPass<::mlir::ModuleOp>(::mlir::TypeID::get<DerivedT>()) {}
  LowerToBMCBase(const LowerToBMCBase &other) : ::mlir::OperationPass<::mlir::ModuleOp>(other) {}
  LowerToBMCBase& operator=(const LowerToBMCBase &) = delete;
  LowerToBMCBase(LowerToBMCBase &&) = delete;
  LowerToBMCBase& operator=(LowerToBMCBase &&) = delete;
  ~LowerToBMCBase() = default;

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("lower-to-bmc");
  }
  ::llvm::StringRef getArgument() const override { return "lower-to-bmc"; }

  ::llvm::StringRef getDescription() const override { return "Lower CIRCTs core dialects to a BMC problem statement"; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("LowerToBMC");
  }
  ::llvm::StringRef getName() const override { return "LowerToBMC"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Return the dialect that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    registry.insert<mlir::func::FuncDialect>();
    registry.insert<mlir::LLVM::LLVMDialect>();
    registry.insert<circt::verif::VerifDialect>();
  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(LowerToBMCBase<DerivedT>)

  LowerToBMCBase(const LowerToBMCOptions &options) : LowerToBMCBase() {
    topModule = options.topModule;
    bound = options.bound;
    insertMainFunc = options.insertMainFunc;
  }
protected:
  ::mlir::Pass::Option<std::string> topModule{*this, "top-module", ::llvm::cl::desc("Name of the top module to verify.")};
  ::mlir::Pass::Option<unsigned> bound{*this, "bound", ::llvm::cl::desc("Cycle bound.")};
  ::mlir::Pass::Option<bool> insertMainFunc{*this, "insert-main", ::llvm::cl::desc("Whether a main function should be inserted for AOT compilation."), ::llvm::cl::init(false)};
private:

  friend std::unique_ptr<::mlir::Pass> createLowerToBMC() {
    return std::make_unique<DerivedT>();
  }

  friend std::unique_ptr<::mlir::Pass> createLowerToBMC(const LowerToBMCOptions &options) {
    return std::make_unique<DerivedT>(options);
  }
};
} // namespace impl

std::unique_ptr<::mlir::Pass> createLowerToBMC() {
  return impl::createLowerToBMC();
}

std::unique_ptr<::mlir::Pass> createLowerToBMC(const LowerToBMCOptions &options) {
  return impl::createLowerToBMC(options);
}
#undef GEN_PASS_DEF_LOWERTOBMC
#endif // GEN_PASS_DEF_LOWERTOBMC
#ifdef GEN_PASS_REGISTRATION

//===----------------------------------------------------------------------===//
// ExternalizeRegisters Registration
//===----------------------------------------------------------------------===//

inline void registerExternalizeRegisters() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return createExternalizeRegisters();
  });
}

// Old registration code, kept for temporary backwards compatibility.
inline void registerExternalizeRegistersPass() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return createExternalizeRegisters();
  });
}

//===----------------------------------------------------------------------===//
// LowerToBMC Registration
//===----------------------------------------------------------------------===//

inline void registerLowerToBMC() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return createLowerToBMC();
  });
}

// Old registration code, kept for temporary backwards compatibility.
inline void registerLowerToBMCPass() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return createLowerToBMC();
  });
}

//===----------------------------------------------------------------------===//
// BMCTransforms Registration
//===----------------------------------------------------------------------===//

inline void registerBMCTransformsPasses() {
  registerExternalizeRegisters();
  registerLowerToBMC();
}
#undef GEN_PASS_REGISTRATION
#endif // GEN_PASS_REGISTRATION
// Deprecated. Please use the new per-pass macros.
#ifdef GEN_PASS_CLASSES

template <typename DerivedT>
class ExternalizeRegistersBase : public ::mlir::OperationPass<::mlir::ModuleOp> {
public:
  using Base = ExternalizeRegistersBase;

  ExternalizeRegistersBase() : ::mlir::OperationPass<::mlir::ModuleOp>(::mlir::TypeID::get<DerivedT>()) {}
  ExternalizeRegistersBase(const ExternalizeRegistersBase &other) : ::mlir::OperationPass<::mlir::ModuleOp>(other) {}
  ExternalizeRegistersBase& operator=(const ExternalizeRegistersBase &) = delete;
  ExternalizeRegistersBase(ExternalizeRegistersBase &&) = delete;
  ExternalizeRegistersBase& operator=(ExternalizeRegistersBase &&) = delete;
  ~ExternalizeRegistersBase() = default;

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("externalize-registers");
  }
  ::llvm::StringRef getArgument() const override { return "externalize-registers"; }

  ::llvm::StringRef getDescription() const override { return "Removes registers and adds corresponding input and output ports"; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("ExternalizeRegisters");
  }
  ::llvm::StringRef getName() const override { return "ExternalizeRegisters"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Register the dialects that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    registry.insert<circt::seq::SeqDialect>();
    registry.insert<circt::hw::HWDialect>();
  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(ExternalizeRegistersBase<DerivedT>)

protected:
};

template <typename DerivedT>
class LowerToBMCBase : public ::mlir::OperationPass<::mlir::ModuleOp> {
public:
  using Base = LowerToBMCBase;

  LowerToBMCBase() : ::mlir::OperationPass<::mlir::ModuleOp>(::mlir::TypeID::get<DerivedT>()) {}
  LowerToBMCBase(const LowerToBMCBase &other) : ::mlir::OperationPass<::mlir::ModuleOp>(other) {}
  LowerToBMCBase& operator=(const LowerToBMCBase &) = delete;
  LowerToBMCBase(LowerToBMCBase &&) = delete;
  LowerToBMCBase& operator=(LowerToBMCBase &&) = delete;
  ~LowerToBMCBase() = default;

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("lower-to-bmc");
  }
  ::llvm::StringRef getArgument() const override { return "lower-to-bmc"; }

  ::llvm::StringRef getDescription() const override { return "Lower CIRCTs core dialects to a BMC problem statement"; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("LowerToBMC");
  }
  ::llvm::StringRef getName() const override { return "LowerToBMC"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Register the dialects that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    registry.insert<mlir::func::FuncDialect>();
    registry.insert<mlir::LLVM::LLVMDialect>();
    registry.insert<circt::verif::VerifDialect>();
  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(LowerToBMCBase<DerivedT>)

protected:
  ::mlir::Pass::Option<std::string> topModule{*this, "top-module", ::llvm::cl::desc("Name of the top module to verify.")};
  ::mlir::Pass::Option<unsigned> bound{*this, "bound", ::llvm::cl::desc("Cycle bound.")};
  ::mlir::Pass::Option<bool> insertMainFunc{*this, "insert-main", ::llvm::cl::desc("Whether a main function should be inserted for AOT compilation."), ::llvm::cl::init(false)};
};
#undef GEN_PASS_CLASSES
#endif // GEN_PASS_CLASSES
