/* Autogenerated by mlir-tblgen; don't manually edit */

#ifdef GEN_PASS_DECL
// Generate declarations for all passes.
#define GEN_PASS_DECL_CONSTRUCTLEC
#undef GEN_PASS_DECL
#endif // GEN_PASS_DECL

//===----------------------------------------------------------------------===//
// ConstructLEC
//===----------------------------------------------------------------------===//
#ifdef GEN_PASS_DECL_CONSTRUCTLEC
struct ConstructLECOptions {
  std::string firstModule;
  std::string secondModule;
  bool insertMainFunc = false;
};
std::unique_ptr<::mlir::Pass> createConstructLEC();
std::unique_ptr<::mlir::Pass> createConstructLEC(const ConstructLECOptions &options);
#undef GEN_PASS_DECL_CONSTRUCTLEC
#endif // GEN_PASS_DECL_CONSTRUCTLEC
#ifdef GEN_PASS_DEF_CONSTRUCTLEC

namespace impl {
  std::unique_ptr<::mlir::Pass> createConstructLEC();
} // namespace impl

namespace impl {
  std::unique_ptr<::mlir::Pass> createConstructLEC(const ConstructLECOptions &options);
} // namespace impl
namespace impl {

template <typename DerivedT>
class ConstructLECBase : public ::mlir::OperationPass<::mlir::ModuleOp> {
public:
  using Base = ConstructLECBase;

  ConstructLECBase() : ::mlir::OperationPass<::mlir::ModuleOp>(::mlir::TypeID::get<DerivedT>()) {}
  ConstructLECBase(const ConstructLECBase &other) : ::mlir::OperationPass<::mlir::ModuleOp>(other) {}
  ConstructLECBase& operator=(const ConstructLECBase &) = delete;
  ConstructLECBase(ConstructLECBase &&) = delete;
  ConstructLECBase& operator=(ConstructLECBase &&) = delete;
  ~ConstructLECBase() = default;

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("construct-lec");
  }
  ::llvm::StringRef getArgument() const override { return "construct-lec"; }

  ::llvm::StringRef getDescription() const override { return "Lower CIRCTs core dialects to a LEC problem statement"; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("ConstructLEC");
  }
  ::llvm::StringRef getName() const override { return "ConstructLEC"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Return the dialect that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    registry.insert<verif::VerifDialect>();
    registry.insert<mlir::func::FuncDialect>();
    registry.insert<mlir::LLVM::LLVMDialect>();
  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(ConstructLECBase<DerivedT>)

  ConstructLECBase(const ConstructLECOptions &options) : ConstructLECBase() {
    firstModule = options.firstModule;
    secondModule = options.secondModule;
    insertMainFunc = options.insertMainFunc;
  }
protected:
  ::mlir::Pass::Option<std::string> firstModule{*this, "first-module", ::llvm::cl::desc("Name of the first of the two modules to compare.")};
  ::mlir::Pass::Option<std::string> secondModule{*this, "second-module", ::llvm::cl::desc("Name of the second of the two modules to compare.")};
  ::mlir::Pass::Option<bool> insertMainFunc{*this, "insert-main", ::llvm::cl::desc("Whether a main function should be inserted for AOT compilation."), ::llvm::cl::init(false)};
private:

  friend std::unique_ptr<::mlir::Pass> createConstructLEC() {
    return std::make_unique<DerivedT>();
  }

  friend std::unique_ptr<::mlir::Pass> createConstructLEC(const ConstructLECOptions &options) {
    return std::make_unique<DerivedT>(options);
  }
};
} // namespace impl

std::unique_ptr<::mlir::Pass> createConstructLEC() {
  return impl::createConstructLEC();
}

std::unique_ptr<::mlir::Pass> createConstructLEC(const ConstructLECOptions &options) {
  return impl::createConstructLEC(options);
}
#undef GEN_PASS_DEF_CONSTRUCTLEC
#endif // GEN_PASS_DEF_CONSTRUCTLEC
#ifdef GEN_PASS_REGISTRATION

//===----------------------------------------------------------------------===//
// ConstructLEC Registration
//===----------------------------------------------------------------------===//

inline void registerConstructLEC() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return createConstructLEC();
  });
}

// Old registration code, kept for temporary backwards compatibility.
inline void registerConstructLECPass() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return createConstructLEC();
  });
}

//===----------------------------------------------------------------------===//
// LECTransforms Registration
//===----------------------------------------------------------------------===//

inline void registerLECTransformsPasses() {
  registerConstructLEC();
}
#undef GEN_PASS_REGISTRATION
#endif // GEN_PASS_REGISTRATION
// Deprecated. Please use the new per-pass macros.
#ifdef GEN_PASS_CLASSES

template <typename DerivedT>
class ConstructLECBase : public ::mlir::OperationPass<::mlir::ModuleOp> {
public:
  using Base = ConstructLECBase;

  ConstructLECBase() : ::mlir::OperationPass<::mlir::ModuleOp>(::mlir::TypeID::get<DerivedT>()) {}
  ConstructLECBase(const ConstructLECBase &other) : ::mlir::OperationPass<::mlir::ModuleOp>(other) {}
  ConstructLECBase& operator=(const ConstructLECBase &) = delete;
  ConstructLECBase(ConstructLECBase &&) = delete;
  ConstructLECBase& operator=(ConstructLECBase &&) = delete;
  ~ConstructLECBase() = default;

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("construct-lec");
  }
  ::llvm::StringRef getArgument() const override { return "construct-lec"; }

  ::llvm::StringRef getDescription() const override { return "Lower CIRCTs core dialects to a LEC problem statement"; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("ConstructLEC");
  }
  ::llvm::StringRef getName() const override { return "ConstructLEC"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Register the dialects that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    registry.insert<verif::VerifDialect>();
    registry.insert<mlir::func::FuncDialect>();
    registry.insert<mlir::LLVM::LLVMDialect>();
  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(ConstructLECBase<DerivedT>)

protected:
  ::mlir::Pass::Option<std::string> firstModule{*this, "first-module", ::llvm::cl::desc("Name of the first of the two modules to compare.")};
  ::mlir::Pass::Option<std::string> secondModule{*this, "second-module", ::llvm::cl::desc("Name of the second of the two modules to compare.")};
  ::mlir::Pass::Option<bool> insertMainFunc{*this, "insert-main", ::llvm::cl::desc("Whether a main function should be inserted for AOT compilation."), ::llvm::cl::init(false)};
};
#undef GEN_PASS_CLASSES
#endif // GEN_PASS_CLASSES
